-- Smooth Trail script by ffoxD.
-- Reusable, use with credit.
local function SmoothTrail(mo, trailmo, freq, color)
    -- Real Z momentum thingy plus leveltime checks.
    -- You can replace all this with mo.momz+mo.pmomz but that stays at 0 when on slopes and on ground.
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    -- Handy local variables.
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    -- The loop, repeats until it spawns all the thok objects.
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
		if (mo.eflags&MFE_VERTICALFLIP) then
			spawnedmo.eflags = $1|MFE_VERTICALFLIP
		end
        spawnedmo.color = color
        spawnedmo.blendmode = AST_ADD -- blend
    end
end

local function animdetect(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.state == S_PLAY_WALLSLIDE1 or player.mo.state == S_PLAY_WALLSLIDE2 or player.mo.state == S_PLAY_WALLSLIDE3 or player.mo.state == S_PLAY_WALLSLIDE4)
		player.slidewallanim = true
	else
		player.slidewallanim = false
	end
end

addHook("PlayerThink", animdetect)

local function jumpeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.pflags&PF_JUMPED) then
		player.thrustfactor = (skins[player.mo.skin].thrustfactor)*2
	else
		player.thrustfactor = skins[player.mo.skin].thrustfactor
	end
end

addHook("PlayerThink", jumpeffect)

local function homingcancel(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usinghomingattack == false or player.usedhomingattack == false) then
		return
	end
	if (player.homingcanceltimer == nil) then
		player.homingcanceltimer = 0
	end
	player.homingcanceltimer = $1 + 1
	if (player.homingcanceltimer > 7*TICRATE) then
		player.usestopp = true
		player.homindjumptimer = nil
		P_SetObjectMomZ(player.mo, 0*FRACUNIT, false)
		player.mo.momx = 0
		player.mo.momy = 0
		player.stpplayer = true
		player.mo.state = S_PLAY_FALL
		player.usinghomingattack = false
		player.lasttarget = nil
		player.lasttargethealth = nil
		player.startresethomingtimer = true
		player.blockhomingjumptimer = false
		player.homindjumptimer2 = nil
		player.homed = false
		player.useeffecttrick = true
		player.homingcanceltimer = nil
	end
end

addHook("PlayerThink", homingcancel)

addHook("MobjDeath", function(mob, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end

	local player = obj.player
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (mob.type ~= MT_RING_BOX) then
		return
	end
	player.ringenergy = $1 + 16
end, MT_NULL)

local function cameraboosteffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.slidewallanim == true and player.midjump == false) or (player.peelfase3 == true) then
		player.camerascale = (skins[player.mo.skin].camerascale)*3/2
	end
	if (player.usingboost == true) then
		player.camerascale = (skins[player.mo.skin].camerascale)/5*2
		if (player.camedited != true) then
			player.camedited = true
			player.lastcameraradius2 = camera.radius
			player.lastcamz = camera.aiming		
			camera.radius = player.lastcameraradius2/20*FRACUNIT
		end
	end
	if (player.slidewallanim == false and player.usingboost == false and player.allowcameraefeftc == false and player.peelfase3 ~= true) then
		player.camerascale = skins[player.mo.skin].camerascale
		camera.radius = player.lastcameraradius
		if (player.camedited == true) then
			player.camedited = false
			camera.aiming = player.lastcamz
			camera.radius = player.lastcameraradius2
		end
	end
end

addHook("PlayerThink", cameraboosteffect)

local function boostbuganim(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == true) then
		return
	end
	if (player.panim == PA_DASH) then
		if (player.speed >= 20*FRACUNIT) then
			player.mo.state = S_PLAY_RUN
		end
		if (player.speed < 20*FRACUNIT and player.speed > 0) then
			player.mo.state = S_PLAY_WALK
		end
		if (player.speed == 0) then
			player.mo.state = S_PLAY_STND
		end
	end
	if (player.slidewallanim == true and player.midjump == false) then
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.state = S_PLAY_STND
	end
end

addHook("PlayerThink", boostbuganim)

local function waitreffill(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.state ~= S_PLAY_WAIT) then
		return
	end
	if (player.ringenergy >= 48) then
		return
	end
	if (player.idlerefilltimer == nil) then
		player.idlerefilltimer = 0
	end
	player.idlerefilltimer = $1 + 1
	if (player.idlerefilltimer == 1*TICRATE/5*2) then
		player.ringenergy = $1 + 4
		player.idlerefilltimer = nil
	end
end

addHook("PlayerThink", waitreffill)

local function anotherrefill(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.lastenergy == nil) then
		player.lastenergy = 0
		return
	end
	if (player.usingboost == true) then
		player.autorefilltimerblublu = nil
		player.artbreu = nil
		return
	end
	if (player.ringenergy >= 48) then
		player.autorefilltimerblublu = nil
		player.artbreu = nil
		return
	end
	if (player.mo.state == S_PLAY_WAIT) then
		player.autorefilltimerblublu = nil
		player.artbreu = nil
		return
	end
	if (player.ringenergy < player.lastenergy) then
		player.lastenergy = player.ringenergy
		player.autorefilltimerblublu = nil
		player.artbreu = nil
		return
	end
	if (player.ringenergy > player.lastenergy) then
		player.lastenergy = player.ringenergy
		return
	end
	if (player.autorefilltimerblublu == nil) then
		player.autorefilltimerblublu = 0
	end
	player.autorefilltimerblublu = $1 + 1
	if (player.autorefilltimerblublu > 18*TICRATE) then
		if (player.artbreu == nil) then
			player.artbreu = 0
		end
		player.artbreu = $1 + 1
		if (player.artbreu == 1*TICRATE/5*3) then
			player.ringenergy = $1 + 4
			player.artbreu = nil
		end
	end
end

addHook("PlayerThink", anotherrefill)

local function effecttrick(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.useeffecttrick == true) then
		if (player.heffecttricktimer == nil) then
			player.heffecttricktimer = 0
		end
		player.heffecttricktimer = $1 + 1
		if (player.heffecttricktimer == 1*TICRATE/10) then
			local EF = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_HOMMINGFALL)
			EF.color = player.mo.color
			EF.angle = player.drawangle
			player.heffecttricktimer = nil
		end
	else
		player.heffecttricktimer = nil
	end
end

addHook("PlayerThink", effecttrick)

local function destranformar(player)
	if not (player.mo and player.mo.valid) then
		return
	end	
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.destrans == true) then
		if (player.mo.momz < 3*FRACUNIT and player.mo.momz > -3*FRACUNIT) then
			P_FlashPal(player, PAL_WHITE, 16)
			S_StartSound(player.mo, sfx_kc31, player)
			S_StartSound(player.mo, sfx_s3k72, player)
			S_StartSound(player.mo, sfx_s3k66, player)
			player.untrnssound = false
			local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_WHITE
			local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_WHITE
			local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_WHITE
			local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_WHITE
			local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_WHITE
			local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_WHITE
			local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_WHITE
			local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_WHITE
			local sprk1s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk1s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1s.color = SKINCOLOR_WHITE
			local sprk2s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk2s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2s.color = SKINCOLOR_WHITE
			local sprk3s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk3s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3s.color = SKINCOLOR_WHITE
			local sprk4s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk4s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4s.color = SKINCOLOR_WHITE
			local sprk5s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk5s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5s.color = SKINCOLOR_WHITE
			local sprk6s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk6s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6s.color = SKINCOLOR_WHITE
			local sprk7s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk7s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7s.color = SKINCOLOR_WHITE
			local sprk8s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
			sprk8s.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8s.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8s.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8s.color = SKINCOLOR_WHITE
			player.mo.state = S_PLAY_FALL
			player.pflags = $&~PF_JUMPED
			player.destrans = false
			player.removetrns = true
		end
		return
	end
	if not (player.powers[pw_super]) then
		if (player.panim == PA_JUMP or player.panim == PA_IDLE or player.panim == PA_WALK) then
			player.lastcolor = player.mo.color
		end
		return
	end
	if (player.drawc3options == false) then
		return
	end
	if (player.destrans == true) then
		return
	end
	if not(player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM2) then
		player.mo.state = S_PLAY_JUMP
		P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
		player.destrans = true
		player.pflags = $|PF_JUMPED
	end
end

addHook("PlayerThink", destranformar)

local function superblock(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blocksuperblock == true) then
		return
	end
	if (player.powers[pw_super] and player.removetrns == false) then
		player.charflags = SF_SUPER|SF_NOSHIELDABILITY
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true) then
		if (player.powers[pw_super]) then
			player.charflags = SF_SUPER|SF_CANBUSTWALLS|SF_NOSHIELDABILITY
		else
			player.charflags = SF_CANBUSTWALLS|SF_NOSHIELDABILITY
		end
		return
	end
	if (player.usinglightdash == true) then
		player.charflags = SF_NOSHIELDABILITY
		return
	end
	if (player.usingboost == true and not player.powers[pw_super]) then
		player.charflags = SF_RUNONWATER|SF_NOSHIELDABILITY
		return
	end
	player.charflags = SF_NOSHIELDABILITY
	player.removetrns = false
end

addHook("PlayerThink", superblock)

local function untranssound(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.rings < 1 and player.untrnssound == true) then
		S_StartSound(player.mo, sfx_kc31, player)
		S_StartSound(player.mo, sfx_s3k72, player)
		S_StartSound(player.mo, sfx_s3k66, player)
		player.untrnssound = false
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = SKINCOLOR_WHITE
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = SKINCOLOR_WHITE
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = SKINCOLOR_WHITE
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = SKINCOLOR_WHITE
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = SKINCOLOR_WHITE
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = SKINCOLOR_WHITE
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = SKINCOLOR_WHITE
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = SKINCOLOR_WHITE
		local sprk1s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1s.color = SKINCOLOR_WHITE
		local sprk2s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2s.color = SKINCOLOR_WHITE
		local sprk3s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3s.color = SKINCOLOR_WHITE
		local sprk4s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4s.color = SKINCOLOR_WHITE
		local sprk5s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5s.color = SKINCOLOR_WHITE
		local sprk6s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6s.color = SKINCOLOR_WHITE
		local sprk7s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7s.color = SKINCOLOR_WHITE
		local sprk8s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8s.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8s.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8s.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8s.color = SKINCOLOR_WHITE
	end
end

addHook("PlayerThink", untranssound)

local function walljumpnose(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.lastx == nil) then
		return
	end
	if (player.lasty == nil) then
		return
	end
	local dist = FixedMul(64*FRACUNIT, player.mo.scale)
	if P_AproxDistance(player.lastx-player.mo.x, player.lasty-player.mo.y) >= dist then
		player.lastx = nil
		player.lasty = nil
	end
end

addHook("PlayerThink", walljumpnose)

addHook("MobjMoveBlocked", function(obj, mob, line)

	local player = obj.player

	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		player.lastx = player.mo.x
		player.lasty = player.mo.y
		return
	end
	if (player.walljumped == true) then
		return
	end
	if (player.usinghomingattack == true) then
		return
	end
	if (player.usedhomingattack == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.useddropthok == true) then
		return
	end		
	if (player.usedsecondarythok == true) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	local dist = FixedMul(96*FRACUNIT, player.mo.scale)
	if (player.lastx ~= nil and player.lasty ~= nil) and (P_AproxDistance(player.lastx-player.mo.x, player.lasty-player.mo.y) < dist) then
		return
	end
	if (player.usedmj == true) then
		return
	end
	if (player.usedbj == true) then
		return
	end
	if (player.walljumpcount == 5) then
		return
	end
	if (player.candropw == true) then
		player.canwalljump = true
		if (mob and mob.valid) then
			player.walljumpangle = R_PointToAngle2(player.mo.x,player.mo.y,mob.x,mob.y)
		end
		if (line and line.valid) then
			player.walljumpangle = R_PointToAngle2(player.mo.x,player.mo.y,P_ClosestPointOnLine(player.mo.x,player.mo.y,line))
		end
	end
end, MT_PLAYER)
//		player.drawangle = player.walljumpangle-ANGLE_180
local function walljump(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.slidewallanim == false) then
		player.twot = nil
	end
	if (player.canwalljump == true) then
		if (player.slidewallanim == false) then
			player.mo.state = S_PLAY_WALLSLIDE1
			S_StartSound(player.mo,sfx_s260)
			S_StartSound(player.mo,sfx_s3k4a)
		end
		P_SetObjectMomZ(player.mo, -1*FRACUNIT, false)
		if not (S_SoundPlaying(player.mo,sfx_s3k7e))
			S_StartSound(player.mo, sfx_s3k7e)
		end
		player.drawangle = player.walljumpangle-ANGLE_180
		camera.momx = 0
		camera.momy = 0
		player.btimer = nil
		player.canwalljump = true
		camera.radius = player.lastcameraradius*3/2
		local dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
		P_InstaThrust(dust, player.drawangle-ANGLE_90, P_RandomRange(16, -16)*FRACUNIT)
		P_SetObjectMomZ(dust, P_RandomRange(4, 2)*FRACUNIT, false)
		if (player.twot == nil) then
			player.twot = 0
		end
		player.twot = $1 + 1
		if (player.twot == 1*TICRATE/7) or (player.cmd.forwardmove < -10) or (player.cmd.buttons&~BT_SPIN) then
			player.canwalljump = false
			player.twot = nil
		end
		if (player.cmd.buttons&BT_JUMP) then
			if not player.pressedwalljump
			player.jumpdthokblock = true
			player.camerascale = (skins[player.mo.skin].camerascale)*3/2
			player.allowcameraefeftc = true
			player.walljumped = true
			if not (player.mo.flags2&MF2_TWOD) then
				P_TryCameraMove(camera, player.mo.x, player.mo.y)
				camera.angle = player.drawangle
			end
			local tk = P_SpawnMobjFromMobj(player.mo, 0, 0, 14*FRACUNIT, MT_ATHOK)
			tk.color = player.mo.color
			P_InstaThrust(player.mo, player.drawangle, 16*FRACUNIT)
			if (player.powers[pw_super] == true) then
				S_StartSound(player.mo,sfx_crnc)
				S_StartSound(player.mo,sfx_kc5f)
				P_SetObjectMomZ(player.mo, 18*FRACUNIT, false)
			else
				S_StartSound(player.mo,sfx_kc52)
				S_StartSound(player.mo,sfx_kc5f)
				P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
			end
			player.canwalljump = false
			player.canusedthok = false
			player.dttimer = nil
			if (player.blockdthok == true)
				player.usedmj2 = true
			end
			if (player.pflags&~PF_JUMPED) then
				player.pflags = $|PF_JUMPED
			end
			if (player.panim ~= PA_FALL) then
				player.mo.state = S_PLAY_FALL
			end
			if (player.walljumpcount < 5) then
				player.walljumpcount = $1 + 1
			end
			player.lastanglewall = nil
		end
			player.pressedwalljump = true
		else
			player.pressedwalljump = false
		end
	end
end

addHook("PlayerThink", walljump)

local function tiemracamef(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.allowcameraefeftc == false) then
		return
	end
	if (player.cmaeraeffectimertutu == nil) then
		player.cmaeraeffectimertutu = 0
	end
	player.cmaeraeffectimertutu = $1 + 1
	if (player.cmaeraeffectimertutu == 1*TICRATE/5*3) then
		player.allowcameraefeftc = false
		player.cmaeraeffectimertutu = nil
	end
end

addHook("PlayerThink", tiemracamef)

local function candrwallreset(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.cmd.buttons&BT_SPIN) or (player.midjump == false) then
		player.candropw = false
	end
end

addHook("PlayerThink", candrwallreset)

local function minitimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		player.minitime = nil
		return
	end
	if (player.startminitimer == false) then
		return
	end
	if (player.minitime == nil) then
		player.minitime = 0
	end
	player.minitime = $1 + 1
	if (player.minitime == 1*TICRATE/8) then
		player.startminitimer = false
		player.minitime = nil
		player.mo.state = S_PLAY_JUMP
	end
end

addHook("PlayerThink", minitimer)

local function canwallreset(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == true and player.slidewallanim == true and player.mo.momz < -2*FRACUNIT) and not (player.mo.eflags&MFE_VERTICALFLIP) then
		player.mo.state = S_PLAY_SPINDASH
		player.startminitimer = true
	end
	if (player.midjump == true and player.slidewallanim == true and player.mo.momz > 2*FRACUNIT) and (player.mo.eflags&MFE_VERTICALFLIP)  then
		player.mo.state = S_PLAY_SPINDASH
		player.startminitimer = true
	end
	if (player.slidewallanim == false) then
		player.canwalljump = false	
	end
end

addHook("PlayerThink", canwallreset)

local function jumpreset(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.midjump == false) then
		player.walljumpangle = player.drawangle
	end 
	if (player.slidewallanim == false) then
		player.walljumpangle = player.drawangle
	end
end

addHook("PlayerThink", jumpreset)

local function walljumpsmooth(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.walljumped == true) then
		local EF = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_HOMMINGFALL)
		EF.color = player.mo.color
		EF.angle = player.drawangle
	end
end

addHook("PlayerThink", walljumpsmooth)

local function unused(player)
	SmoothTrail(player.mo, MT_BTHOK, 4*FRACUNIT, player.mo.color)
end

local function jumpedoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.walljumped == false) then
		return
	end
	if (player.walltimer == nil) then
		player.walltimer = 0
	end
	player.walltimer = $1 + 1
	if (player.walltimer == 1*TICRATE/5) then
		player.mo.state = S_PLAY_JUMP
		player.walljumped = false
		player.walltimer = nil
	end
end

addHook("PlayerThink", jumpedoff)

local function invecarscudo(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.rings < 30) then
		return
	end
	if (player.powers[pw_shield] ~= SH_NONE) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.drawc3options == true and player.cmd.buttons&BT_SPIN) then
		if (gametype == GT_COOP) then
			player.pyrdetect = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PLAYERDECTECTOR)
		end
		P_SwitchShield(player, SH_PITY)
		S_StartSound(player.mo, sfx_s1af, player)
		player.usedorbin = true
		player.rings = $1 - 30
	end
end

addHook("PlayerThink", invecarscudo)

local function desinvecarscudo(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.pyrdetect and player.pyrdetect.valid) then
		return
	end
	if (player.orbtimer == nil) then
		player.orbtimer = 0
	end
		player.orbtimer = $1 + 1
	if (player.orbtimer >= 1*TICRATE/5) then
		player.orbtimer = nil
		if (player.pyrdetect and player.pyrdetect.valid) then
			P_KillMobj(player.pyrdetect)
		end
	end
end

addHook("PlayerThink", desinvecarscudo)

local function detectorbpl(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end

	for mo in mobjs.iterate()

		if (mo.health <= 0) then -- Not a valid ring
			continue
        end

		if not (mo.type == MT_PLAYERDECTECTOR)
			continue
        end

		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > 96*FRACUNIT) -- Out of range
			continue
        end
		if (player.powers[pw_shield] ~= SH_NONE) then
			continue
		end
		if (player.powers[pw_super]) then
			continue
		end
		P_SwitchShield(player, SH_PITY)
		S_StartSound(player.mo, sfx_s1af, player)
	end
end

addHook("PlayerThink", detectorbpl)

local function setc3optrue(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM3) then
		player.drawc3options = true
		if (player.rings >= 30) then
			player.charability2 = CA2_NONE
		end
	else
		if (player.rings >= 30 and player.drawc3options == true and player.charability2 == CA2_NONE) then
			player.charability2 = CA2_SPINDASH
		end
		player.drawc3options = false
	end
end

addHook("PlayerThink", setc3optrue)

local function spinningbug(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		player.pflags = $&~PF_SPINNING
	end
end

addHook("PlayerThink", spinningbug)

local function blockmjinstartingbounce(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingbouncejump == false) then
		return
	end
	if (player.allowmj == true) then
		return
	end
	if (player.anotherbouncetimer == nil) then
		player.anotherbouncetimer = 0
	end
	player.anotherbouncetimer = $1 + 1
	if (player.anotherbouncetimer == 1*TICRATE/7) then
		player.allowmj = true
		player.anotherbouncetimer = nil
	end
end

addHook("PlayerThink", blockmjinstartingbounce)

local function cantthok(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		if not (player.cmd.buttons&BT_SPIN) then
			player.jumpdthokblock = true
		end
	end
	if (player.midjump == false and player.cmd.buttons&BT_JUMP) then
		player.jumpdthokblock = true
	end
	if not (player.cmd.buttons&BT_JUMP) then
		player.jumpdthokblock = false
	end
end

addHook("PlayerThink", cantthok)