-- Smooth Trail script by ffoxD.
-- Reusable, use with credit.
local function SmoothTrail(mo, trailmo, freq, color)
    -- Real Z momentum thingy plus leveltime checks.
    -- You can replace all this with mo.momz+mo.pmomz but that stays at 0 when on slopes and on ground.
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    -- Handy local variables.
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    -- The loop, repeats until it spawns all the thok objects.
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
		if (mo.eflags&MFE_VERTICALFLIP) then
			spawnedmo.eflags = $1|MFE_VERTICALFLIP
		end
        spawnedmo.color = color
        spawnedmo.blendmode = AST_ADD -- blend
    end
end


-- Detect Rings, coins and Bluespheres by ffoxD (with a additions by me)--

local function detectrings(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usinglightdash == false) then
		player.ringtarget = nil
		return
	end
    player.ringtarget = nil

	for mo in mobjs.iterate()

		if (mo.health <= 0) then -- Not a valid ring
			continue
        end

		if not (mo.type == MT_RING or mo.type == MT_COIN or mo.type == MT_BLUESPHERE)
			continue
        end

		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > 256*FRACUNIT) -- Out of range
			continue
        end

		if not P_CheckSight(player.mo, mo) -- Out of sight
			continue
        end

		if (player.ringtarget and P_AproxDistance(P_AproxDistance(player.mo.x-mo.x,
			player.mo.y-mo.y), player.mo.z-mo.z) >
			P_AproxDistance(P_AproxDistance(player.mo.x-player.ringtarget.x,
			player.mo.y-player.ringtarget.y), player.mo.z-player.ringtarget.z))
			continue
        end
		player.ringtarget = mo
		player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, mo.x, mo.y)
	end
end

addHook("PlayerThink", detectrings)

-- Smoth Spin by ffoxD --

addHook ("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then
		return
	end
	if (p.mo.skin ~= "spsonic") then
		return
	end
	if (p.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (p.mo.flags2 & MF2_TWOD) then
		return
	end
	if (p.cmd.buttons&BT_SPIN) then
		p.thrustfactor = skins[p.mo.skin].thrustfactor
		return
	end
	if not (p.pflags & PF_SPINNING) then
		if not (p.panim&PA_JUMP) then
			p.thrustfactor = skins[p.mo.skin].thrustfactor
			p.normalspeed = skins[p.mo.skin].normalspeed
		else
			p.thrustfactor = (skins[p.mo.skin].thrustfactor)*2
			p.normalspeed = skins[p.mo.skin].normalspeed
		end
		return
	end
	if p.pflags & PF_SPINNING and not (p.pflags & PF_STARTDASH) and P_IsObjectOnGround(p.mo) then
		p.thrustfactor = (skins[p.mo.skin].thrustfactor)*28
		p.normalspeed = (skins[p.mo.skin].normalspeed)*2
	else
		p.thrustfactor = skins[p.mo.skin].thrustfactor
		p.normalspeed = skins[p.mo.skin].normalspeed
	end
end)

addHook("MobjCollide", function(mob, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end
	local player = obj.player

	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.pflags & PF_SPINNING) then
		return
	end
	if not (player.panim&PA_ROLL) then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (mob.flags&MF_ENEMY) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-mob.x, player.mo.y-mob.y), player.mo.z-mob.z) < spkdist) then
		if (player.mo.z >= mob.z-mob.scale and player.mo.z <= mob.z+mob.scale) then
			P_InstaThrust(player.mo, player.drawangle, player.speed+8*FRACUNIT)
		end
	end
end, MT_NULL)


-- Speed Wind (from SpeedEffects) by AurumMighty --

local function Wind(mobj)
    local r = mobj.radius / FRACUNIT
    local explosion = P_SpawnMobj(
        mobj.x + (P_RandomRange(r, -r) * FRACUNIT),
        mobj.y + (P_RandomRange(r, -r) * FRACUNIT),
        mobj.z + (P_RandomKey(mobj.height / FRACUNIT) * FRACUNIT) - mobj.height/2,
        MT_THOK)
    explosion.sprite = SPR_RAIN
    explosion.renderflags = $|RF_PAPERSPRITE
    explosion.angle = R_PointToAngle2(0, 0, mobj.momx, mobj.momy)
    explosion.rollangle = R_PointToAngle2(0, 0, R_PointToDist2(0, 0, mobj.momx, mobj.momy), -mobj.momz) + ANGLE_90
    explosion.source = mobj
    explosion.blendmode = AST_ADD
end

local function spdwind(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.speed > 45*FRACUNIT) then
		Wind(player.mo)
	end
end

addHook("PlayerThink", spdwind)

-- Save MB charges, reused from ManyMinorTweaks (credits to EeveeEuphoria)--

addHook("ThinkFrame", function()
    for player in players.iterate do
		if (player.powers[pw_carry] == CR_NIGHTSMODE) then
			return
		end
		if not (player and player.valid) then
			break
		end
		if (G_EnoughPlayersFinished()) then
			if not (player.savedcharges) and not (G_IsSpecialStage(gamemap)) then
				player.savedcharges = true
				player.levelname = mapheaderinfo[gamemap].lvlttl
				if (player.youhave1pyect == true) then
					player.unitsofpyects = 1
				end
				if (player.youhave2pyect == true) then
					player.unitsofpyects = 2
				end
				if (player.youhave3pyect == true) then
					player.unitsofpyects = 3
				end
			end
		elseif (player.savedcharges and not G_IsSpecialStage(gamemap)) then
			if (player.youhave1pyect == false and player.youhave2pyect == false and player.youhave3pyect == false) then
				if (player.levelname == mapheaderinfo[gamemap].lvlttl) then
					player.savedcharges = false
					if (player.unitsofpyects == 1) then
						player.youhave1pyect = true
						player.youhave2pyect = false
						player.youhave3pyect = false
						player.unitsofpyects = 0
					end
					if (player.unitsofpyects == 2) then
						player.youhave1pyect = false
						player.youhave2pyect = true
						player.youhave3pyect = false
						player.unitsofpyects = 0
					end
					if (player.unitsofpyects == 3) then
						player.youhave1pyect = false
						player.youhave2pyect = false
						player.youhave3pyect = true
						player.unitsofpyects = 0
					end
				end
			end
		end
	end
end)

-- Thanks ffoxD for the LightDash, smooth trail and smooth spin. --
-- Also, thanks to AurumMighty for the Speed Wind effect --

-- SP.Sonic by ElHaker_2006 --

local function spinrexd(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.speed < 15*FRACUNIT) then
		return
	end
	if (player.pflags&PF_JUMPED) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.panim&PA_ROLL) then
		return
	end
	if (player.pflags&PF_SPINNING and player.powers[pw_shield] ~= SH_ELEMENTAL) or (player.pflags&PF_SPINNING and player.powers[pw_shield] == SH_ELEMENTAL and player.mo.eflags&MFE_UNDERWATER) or (player.pflags&PF_SPINNING and player.powers[pw_super]) then
		SmoothTrail(player.mo, MT_CTHOK, 8*FRACUNIT, player.mo.color)
	end
	if (player.powers[pw_super] == true) then
		return
	end
	if (player.mo.eflags&MFE_UNDERWATER) then
		return
	end
	if (player.pflags&PF_SPINNING and player.powers[pw_shield] == SH_ELEMENTAL) then
		SmoothTrail(player.mo, MT_CTHOK, 8*FRACUNIT, SKINCOLOR_KETCHUP)
	end
end

addHook("PlayerThink", spinrexd)

local function spinrexd2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.pflags&PF_JUMPED) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.panim&PA_ROLL) then
		return
	end
	if (player.pflags&PF_JUMPED) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.useddropthok == true) then
		return
	end
	if (player.usedsecondarythok == true) then
		return
	end
	if (player.pflags&PF_SPINNING and player.cmd.buttons&BT_JUMP) then
		player.jumpdthokblock = true
		P_DoJump(player, true)
		P_SpawnGhostMobj(player.mo)
		player.dropsound = true
		if (player.pflags&PF_SPINNING) then
			player.pflags = $&~PF_SPINNING
		end
		if not (player.powers[pw_super]) then
			player.blockdthok = true
			player.usedsecondarythok = false
			player.canusest = true
			player.usedrecull = true
			player.usedmj2 = true
		end
	end
end

addHook("PlayerThink", spinrexd2)

-- If you're dead, desactivate all --

local function blockallifyouaredead(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.spectator == true) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		player.lastenergy = player.ringenergy
		player.useeffecttrick = false
		player.startresethomingtimer = false
		player.untrnssound = false
		player.walljumpcount = 0
		player.blockwalljump = true
		player.canwalljump = false
		player.walljumped = false
		player.wallcanceltimer = nil
		player.blockallabilities = true
		player.mo.colorized = false
		player.sbcolortimer = nil
		player.canusepdblst = false
		player.usingspdblast = false
		player.startingspdblst = false
		player.sdbstftimer = nil
		player.sbstartingtimer = nil
		player.sbcolortimer = nil
		player.lastangle = nil
		player.mo.target = nil
		player.mo.tracer = nil
		player.sbup = false
		player.usedmj2 = false
		player.allowtrick = false
		player.droptimer = nil
		player.sdroptimer = nil
		player.sbforw = false
		player.sbback = false
		player.sbright = false
		player.sbleft = false
		player.mo.state = S_PLAY_DEAD
		player.activatelightdash = false
	end
end

addHook("PlayerThink", blockallifyouaredead)

local function fallandspringeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.panim == PA_ROLL) then
		return
	end
	if (player.panim == PA_JUMP) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.panim == PA_PAIN) then
		return
	end
	if (player.panim == PA_RIDE) then
		return
	end
	if (player.mo.state == S_PLAY_DEAD) then
		return
	end
	if (player.mo.state == S_PLAY_DRWN) then
		return
	end
	if (player.panim == PA_ABILITY) then
		return
	end
	if (player.panim == PA_ABILITY2) then
		return
	end
	if (player.pflags&PF_JUMPED) then
		return
	end
	if (player.slidewallanim == true) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedhomingattack == true) then
		return
	end
	if (player.mo.momz > 0) then
		player.mo.state = S_PLAY_SPRING
	end
	if (player.mo.momz < 0) then
		player.mo.state = S_PLAY_FALL
	end
end

addHook("PlayerThink", fallandspringeffect)	

local function resetplayersspeed(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.activatelightdash == false and player.normalspeed == 16*FRACUNIT) then
		player.normalspeed = 36*FRACUNIT
	end
end

addHook("PlayerThink", resetplayersspeed)

local function resetspincount(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		player.canaddcount = false
		return
	end
	if (player.spincount == true) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		if not player.pressedspincount
		player.canaddcount = true
	end
		player.pressedspincount = true
	else
		player.pressedspincount = false
	end
end

addHook("PlayerThink", resetspincount)		

local function spinresetrimer(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.spincount == false) then
		player.rstspincounttimer = nil
		return
	end
	if (player.startrstspinttimer == false) then
		return
	end
	if (player.rstspincounttimer == nil) then
		player.rstspincounttimer = 0
	end

	player.rstspincounttimer = $1 + 1

	if (player.rstspincounttimer > 1*TICRATE/5) then
		player.spincount = false
		player.startrstspinttimer = false
		player.rstspincounttimer = nil
	end
end

addHook("PlayerThink", spinresetrimer)

local function addspincounter(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.canaddcount == true) then
		player.spincount = true
		player.canaddcount = false
		player.startrstspinttimer = true
	end
end

addHook("PlayerThink", addspincounter)

local function blockallifyouareinpain(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if P_PlayerInPain(player) then
		player.untrnssound = false
		player.useeffecttrick = false
		player.startresethomingtimer = false
		player.checkposition = nil
		player.walljumpcount = 3
		player.lastanglewall = nil
		player.walljumped = false
		player.canwalljump = false
		player.wallcanceltimer = nil
		player.startrstspinttimer = false
		player.spincount = false
		player.canaddcount = false
		player.canusebouncejump = true
		player.blockallabilities = true
		player.mo.state = S_PLAY_PAIN
		player.mo.colorized = false
		player.sbcolortimer = nil
		player.canusepdblst = false
		player.usingspdblast = false
		player.startingspdblst = false
		player.sdbstftimer = nil
		player.sbstartingtimer = nil
		player.sbcolortimer = nil
		player.lastangle = nil
		player.sbup = false
		player.usedmj2 = false
		player.allowtrick = false
		player.droptimer = nil
		player.sdroptimer = nil
		player.sbforw = false
		player.sbback = false
		player.sbright = false
		player.sbleft = false
		player.mo.state = S_PLAY_PAIN
		player.activatelightdash = false
		player.usedlightdash = false
		player.usinglightdash = false
		if (player.activatelightdash == false) and (player.lightdashlight and player.lightdashlight.valid) then
			P_KillMobj(player.lightdashlight)
		end
	end
end

addHook("PlayerThink", blockallifyouareinpain)

-- Nights --

local function mmmnight(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.spsoniccolored == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE and player.mo.state == S_PLAY_NIGHTS_TRANS6) or
	(player.trnsnightssuper == true) then
		player.trnsnightssuper = true
		player.powers[pw_super] = 1
	end
end

addHook("PlayerThink", mmmnight)

-- set false if you are an another skin --

local function resetsink(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		if (player.canboostalt == nil) then
			player.canboostalt = false
		end
		if (player.boostalt == nil) then
			player.boostalt = false
		end
		if (player.blockc1cancel == nil) then
			player.blockc1cancel = false
		end
		player.colorbghoost = false
		player.lastcameraradius = camera.radius
		player.allowcameraefeftc = false
		player.lastenergy = player.ringenergy
		player.untrnssound = false
		player.useeffecttrick = false
		player.startresethomingtimer = false
		player.checkposition = nil
		player.walljumpcount = 0
		player.blockwalljump = false
		player.lastanglewall = nil
		player.canwalljump = false
		player.walljumped = false
		player.wallcanceltimer = nil
		player.findmonitor = nil
		player.canaddcount = false
		player.startrstspinttimer = false
		player.rstspincounttimer = nil
		player.spincount = false
		player.canusebouncejump = true
		player.blockringrefill = false
		player.lastrings = nil
		player.usedsuperringrefill = false
		player.youhave1pyect = false
		player.youhave2pyect = false
		player.youhave3pyect = false
		player.mbtarget = nil
		player.mbtarget1 = nil
		player.mbtarget2 = nil
		player.mbtarget3 = nil
		player.mbtargetair = nil
		player.usingmbp = false
		player.reculltimer = nil
		player.mjtimer = nil
		player.retimer = nil
		player.trnsnightssuper = false
		player.remaxcolor = false
		player.usingdash = false
		player.peelfase1 = false
		player.usingws = false
		player.mbef1timer = nil
		player.mbef2timer = nil
		player.mbef3timer = nil
		player.mbeffect1_1 = false
		player.mbeffect1_2 = false
		player.mbeffect2_1 = false
		player.mbeffect2_2 = false
		player.mbeffect3_1 = false
		player.mbeffect3_2 = false
		player.springtarget = nil
		player.sprk1mb = nil
		player.sprk2mb = nil
		player.sprk3mb = nil
		player.peelfase2 = false
		player.lightrings = nil
		player.upringtimer = nil
		player.peelfase3 = false
		player.peeltimer = nil
		player.usingmbp = false
		player.peeltimer2 = nil
		player.usingpeel = false
		player.canusepeel = true
		player.usingboost = false
		player.blimitants = true
		player.midjump = false
		player.droptimer = nil
		player.sdroptimer = nil
		player.camlightimer = nil
		player.lasttkangle = nil
		player.superdropdash = false
		player.dropdash = false
		player.wtimer = nil
		player.lightlastangle = nil
		player.bjauraeffect = false
		player.bounceinspring = false
		player.usedisair = false
		player.usedrecull = false
		player.usingbouncejump = false
		player.bouncenum = 0
		player.ldstimer = nil
		player.canuseisairs = true
		player.canusedropdash = true
		player.instatarget = nil
		player.canusedthok = false
		player.usedshield = false
		player.canusest = false
		player.dttimer = nil
		player.startttimer = false
		player.usedsecondarythok = false
		player.usedmj = false
		player.usedis = false
		player.canuseboost = true
		player.bsretimer = nil
		player.canusehoming = true
		player.usinghomingattack = false
		player.usedhomingattack = false
		player.sspsoniclight = nil
		player.homingtarget = nil
		player.usestopp = false
		player.stpplayer = false
		player.fse3colortimer2 = nil
		player.htimer = nil
		player.allowtrick = false
		player.usingisair = false
		player.usingfly = false
		player.activatelightdash = false
		player.ldetarget1 = nil
		player.ldetarget2 = nil
		player.ldetarget3 = nil
		player.sbetarget1 = nil
		player.sbetarget2 = nil
		player.sbetarget3 = nil
		player.lightdashlight = nil
		player.usedib = false
		player.bounceinspring = false
		player.ldtimer = nil
		player.lighting = false
		player.usedlightdash = false
		player.usinglightdash = false
		player.activatelightdash = false
		player.lotimer = nil
		player.fse3colortimer = nil
		player.ultimer = nil
		player.canskid = false
		player.bstgtimer = nil
		player.lddist = nil
		player.sbcolortimer = nil
		player.usedmj2 = false
		player.canusepdblst = false
		player.usingspdblast = false
		player.startingspdblst = false
		player.sdbstftimer = nil
		player.sbstartingtimer = nil
		player.sbcolortimer = nil
		player.lastangle = nil
		player.sbup = false
		player.sbforw = false
		player.sbback = false
		player.sbright = false
		player.sbleft = false
		player.sbanalog = false
		player.blockallabilities = false
	end
end

addHook("PlayerThink", resetsink)

-- set all false for default --

local function setfalsedefault(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		player.trnsnightssuper = false
		return
	end
	if (player.canboostalt == nil) then
		player.canboostalt = false
	end
	if (player.boostalt == nil) then
		player.boostalt = false
	end
	if (player.blockc1cancel == nil) then
		player.blockc1cancel = false
	end
	player.colorbghoost = false
	player.allowcameraefeftc = false
	player.lastcameraradius = camera.radius
	player.lastenergy = player.ringenergy
	player.untrnssound = false
	player.useeffecttrick = false
	player.startresethomingtimer = false
	player.walljumpcount = 0
	player.blockwalljump = false
	player.walljumped = false
	player.lastanglewall = nil
	player.canwalljump = false
	player.wallcanceltimer = nil
	player.findmonitor = nil
	player.startrstspinttimer = false
	player.canaddcount = false
	player.rstspincounttimer = nil
	player.spincount = false
	player.canusebouncejump = true
	player.ringenergy = 48
	player.blockringrefill = false
	player.lastrings = nil
	player.usedsuperringrefill = false
	player.youhave1pyect = false
	player.youhave2pyect = false
	player.youhave3pyect = false
	player.mbtarget = nil
	player.mbtarget1 = nil
	player.mbtarget2 = nil
	player.mbtarget3 = nil
	player.mbtargetair = nil
	player.usingmbp = false
	player.reculltimer = nil
	player.lightrings = nil
	player.mjtimer = nil
	player.retimer = nil
	player.trnsnightssuper = false
	player.remaxcolor = false
	player.usingdash = false
	player.peelfase1 = false
	player.usingws = false
	player.mbef1timer = nil
	player.mbef2timer = nil
	player.mbef3timer = nil
	player.mbeffect1_1 = false
	player.mbeffect1_2 = false
	player.mbeffect2_1 = false
	player.mbeffect2_2 = false
	player.mbeffect3_1 = false
	player.mbeffect3_2 = false
	player.springtarget = nil
	player.sprk1mb = nil
	player.sprk2mb = nil
	player.sprk3mb = nil
	player.peelfase2 = false
	player.upringtimer = nil
	player.peelfase3 = false
	player.peeltimer = nil
	player.usingmbp = false
	player.peeltimer2 = nil
	player.usingpeel = false
	player.canusepeel = true
	player.usingboost = false
	player.blimitants = true
	player.midjump = false
	player.droptimer = nil
	player.sdroptimer = nil
	player.camlightimer = nil
	player.lasttkangle = nil
	player.superdropdash = false
	player.dropdash = false
	player.wtimer = nil
	player.lightlastangle = nil
	player.bjauraeffect = false
	player.usedisair = false
	player.usedrecull = false
	player.usingbouncejump = false
	player.bouncenum = 0
	player.ldstimer = nil
	player.canuseisairs = true
	player.canusedropdash = true
	player.instatarget = nil
	player.canusedthok = false
	player.usedshield = false
	player.canusest = false
	player.dttimer = nil
	player.startttimer = false
	player.usedsecondarythok = false
	player.usedmj = false
	player.usedis = false
	player.canuseboost = true
	player.bsretimer = nil
	player.bounceinspring = false
	player.canusehoming = true
	player.usinghomingattack = false
	player.usedhomingattack = false
	player.mo.target = nil
	player.ringtarget = nil
	player.sspsoniclight = nil
	player.homingtarget = nil
	player.usestopp = false
	player.stpplayer = false
	player.fse3colortimer2 = nil
	player.htimer = nil
	player.allowtrick = false
	player.usingisair = false
	player.usingfly = false
	player.activatelightdash = false
	player.ldetarget1 = nil
	player.ldetarget2 = nil
	player.ldetarget3 = nil
	player.sbetarget1 = nil
	player.sbetarget2 = nil
	player.sbetarget3 = nil
	player.lightdashlight = nil
	player.usedib = false
	player.ldtimer = nil
	player.lighting = false
	player.mo.target = nil
	player.ringtarget = nil
	player.usedlightdash = false
	player.usinglightdash = false
	player.activatelightdash = false
	player.lotimer = nil
	player.fse3colortimer = nil
	player.ultimer = nil
	player.canskid = false
	player.bstgtimer = nil
	player.lddist = nil
	player.mo.colorized = false
	player.sbcolortimer = nil
	player.usedmj2 = false
	player.canusepdblst = false
	player.usingspdblast = false
	player.startingspdblst = false
	player.sdbstftimer = nil
	player.sbstartingtimer = nil
	player.sbcolortimer = nil
	player.lastangle = nil
	player.sbup = false
	player.sbforw = false
	player.sbback = false
	player.sbright = false
	player.sbleft = false
	player.sbanalog = false
	player.blockallabilities = false
end

addHook("PlayerSpawn", setfalsedefault)

local function ifisongroundacitvate(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_IsObjectOnGround(player.mo) then
		player.allowcameraefeftc = false
		player.useeffecttrick = false
		player.startresethomingtimer = false
		player.walljumpcount = 0
		player.lastanglewall = nil
		player.walljumped = false
		player.canwalljump = false
		player.wallcanceltimer = nil
		player.startrstspinttimer = false
		player.canaddcount = false
		player.spincount = false
		player.canusebouncejump = true
		player.canusepeel = true
		player.dttimer = nil
		player.midjump = false
		player.canusedthok = false
		player.blockdthok = false
		player.canusedropdash = true
		player.usedib = false
		player.usedsecondarythok = false
		player.canusest = false
		player.usedmj = false
		player.usedbj = false
		player.usedis = false
		player.bjauraeffect = false
		player.usestopp = false
		player.reculltimer = nil
		player.usinghomingattack = false
		player.usedhomingattack = false
		player.canusehoming = true
		player.homingtarget = nil
		player.droptimer = nil
		player.sdroptimer = nil
		player.usedshield = false
		player.stpplayer = false
		player.htimer = nil
		player.wtimer = nil
		player.usingws = false
		player.usedmj2 = false
		player.mjtimer = nil
		player.allowtrick = false
		player.usingisair = false
		player.canuseisair = true
		player.blockallabilities = false
		player.usingfly = false
		if (player.usingbouncejump == false) then
			player.bouncenum = 0
			player.bounceinspring = false
			if not (player.charability2 == CA2_SPINDASH) and not (player.drawc3options == true) then
				player.charability2 = CA2_SPINDASH
			end
		else
			if (player.charability2 == CA2_SPINDASH) then
				player.charability2 = $1&~CA2_SPINDASH
			end			
		end		
	else
		player.midjump = true
		player.peelfase1 = false
		player.peelfase2 = false
		player.peelfase3 = false
		player.peeltimer = nil
		player.peeltimer2 = nil
		if (player.usingpeel == true) then
			player.mo.colorized = false
			player.usingpeel = false
		end
		if (player.usedmj == false) then
			player.usedmj2 = false
			player.mjtimer = nil
		end
	end
	if (player.pflags&PF_FINISHED) then
		player.canusepeel = true
		player.dttimer = nil
		player.midjump = false
		player.canusedthok = false
		player.canusedropdash = true
		player.usedib = false
		player.usedsecondarythok = false
		player.canusest = false
		player.usedmj = false
		player.usedbj = false
		player.usedis = false
		player.bjauraeffect = false
		player.usestopp = false
		player.usinghomingattack = false
		player.canusehoming = true
		player.homingtarget = nil
		player.usedshield = false
		player.mo.target = nil
		player.stpplayer = false
		player.htimer = nil
		player.wtimer = nil
		player.usingws = false
		player.allowtrick = false
		player.usingisair = false
		player.canuseisair = true
		player.blockallabilities = false
		player.usingfly = false
	end
end

addHook("PlayerThink", ifisongroundacitvate)

-- Bugs --

local function boostsoundbug(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == false) then
		S_StopSoundByID(player.mo, sfx_bostw)
		player.bstgtimer = nil
	end
end

addHook("PlayerThink", boostsoundbug)

local function trickbugusedhoming(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim ~= PA_JUMP) or (player.usinghoming == false) or (player.midjump == false) then
		player.allowtrick = false
	end
end

addHook("PlayerThink", trickbugusedhoming)

local function usedbjfalsebugxd(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedbj == false) then
		player.bjtimer = nil
	end
end

addHook("PlayerThink", usedbjfalsebugxd)

local function homingjumpbug(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim == PA_FALL) or
	(player.midjump == false) then
		player.homindjumptimer = nil
		player.homindjumptimer2 = nil
		player.homed = false
	end
end

addHook("PlayerThink", homingjumpbug)

local function anotherbjbug(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim ~= PA_ROLL) then
		player.bjtimer = nil
		player.usedbj = false
	end
end

addHook("PlayerThink", anotherbjbug)

local function lightdashbug(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.activatelightdash == true) then
		player.blockallabilities = true
		player.normalspeed = 16*FRACUNIT
	end
end

addHook("PlayerThink", lightdashbug)

-- RING ENERGY --

-- Max effect --

local function maxrientimer(player)
	if not (player.mo and player.mo.valid) then
		return 
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.ringenergy ~= 80) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.retimer == nil) then
		player.retimer = 0
		end
	
	player.retimer = $1 + 1
	
	if (player.retimer == 1*TICRATE/9 and player.remaxcolor == true) then		
		player.remaxcolor = false
		player.retimer = nil
		return
	end
	if (player.retimer == 1*TICRATE/9 and player.remaxcolor == false) then	
		player.remaxcolor = true
		player.retimer = nil
		return
	end
end

addHook("PlayerThink", maxrientimer)

-- Refill --

local function ringrefill(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.blockringrefill == true) then
		return
	end
	A_FindTarget(player.mo, MT_RING, 0)
	A_FindTarget(player.mo, MT_COIN, 0)
	local ringdist = FixedMul(96*FRACUNIT, player.mo.scale)
	
	if (player.ringenergy > 80) then
		player.ringenergy = 80
		return
	end
	if (player.ringenergy < 0) then
		player.ringenergy = 0
	end
	if (player.ringenergy == 80) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.mo.target == nil) then
		return
	end
	if not (player.mo.target and player.mo.target.valid) then
		return
	end
	if not (P_AproxDistance(P_AproxDistance(player.mo.x-player.mo.target.x, player.mo.y-player.mo.target.y), player.mo.z-player.mo.target.z) < ringdist) then
		player.lastrings = player.rings
		return
	end
	if (player.lastrings == nil) then
		return
	end
	if (player.rings > player.lastrings) then
		player.ringenergy = $1 + 8
		player.lastrings = player.rings	
	end
end

addHook("PlayerThink", ringrefill)

-- MAGIC BRACLET --

-- Magic effect --

local function magiceffect1_1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect1_2 == true) then
		return
	end
	if (player.mbeffect1_1 == true) then
		P_SetObjectMomZ(player.sprk1mb, 2*FRACUNIT, false)
	end
end

addHook("PlayerThink", magiceffect1_1)

local function magiceffect1_2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect1_1 == true) then
		return
	end
	if (player.mbeffect1_2 == true) then
		A_HomingChase(player.sprk1mb, 24*FRACUNIT)
	end
end

addHook("PlayerThink", magiceffect1_2)

local function magiceffect1and2dead(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect1_1 == true) then
		return
	end
	if (player.mbeffect1_2 == false) then
		return
	end
	local sprkdist = FixedMul(8*FRACUNIT, player.mo.scale)
	if (P_AproxDistance(P_AproxDistance(player.mo.x-player.sprk1mb.x, player.mo.y-player.sprk1mb.y), player.mo.z-player.sprk1mb.z) < sprkdist)
		P_KillMobj(player.sprk1mb)
		player.sprk1mb = nil
		player.mbeffect1_1 = false
		player.mbeffect1_2 = false
	end
end

addHook("PlayerThink", magiceffect1and2dead)

local function timermagiceffect1_2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.mbeffect1_2 == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect1_1 == false) then
		return
	end
	if (player.mbef1timer == nil) then
		player.mbef1timer = 0
	end

	player.mbef1timer = $1 + 1

	if (player.mbef1timer == 2*TICRATE) then
		player.sprk1mb.target = player.mo
		player.mbeffect1_2 = true
		player.mbeffect1_1 = false
		player.mbef1timer = nil
	end
end

addHook("PlayerThink", timermagiceffect1_2)

local function magiceffect2_1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect2_2 == true) then
		return
	end
	if (player.mbeffect2_1 == true) then
		P_SetObjectMomZ(player.sprk2mb, 2*FRACUNIT, false)
	end
end

addHook("PlayerThink", magiceffect2_1)

local function magiceffect2_2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect2_1 == true) then
		return
	end
	if (player.mbeffect2_2 == true) then
		A_HomingChase(player.sprk2mb, 24*FRACUNIT)
	end
end

addHook("PlayerThink", magiceffect2_2)

local function magiceffect2_1and2_2dead(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect2_1 == true) then
		return
	end
	if (player.mbeffect2_2 == false) then
		return
	end
	local sprkdist = FixedMul(8*FRACUNIT, player.mo.scale)
	if (P_AproxDistance(P_AproxDistance(player.mo.x-player.sprk2mb.x, player.mo.y-player.sprk2mb.y), player.mo.z-player.sprk2mb.z) < sprkdist)
		P_KillMobj(player.sprk2mb)
		player.sprk2mb = nil
		player.mbeffect2_1 = false
		player.mbeffect2_2 = false
	end
end

addHook("PlayerThink", magiceffect2_1and2_2dead)

local function magiceffect2_2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.mbeffect2_2 == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect2_1 == false) then
		return
	end
	if (player.mbef2timer == nil) then
		player.mbef2timer = 0
	end

	player.mbef2timer = $1 + 1

	if (player.mbef2timer == 2*TICRATE) then
		player.sprk2mb.target = player.mo
		player.mbeffect2_2 = true
		player.mbeffect2_1 = false
		player.mbef2timer = nil
	end
end

addHook("PlayerThink", magiceffect2_2)

local function magiceffect3_1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect3_2 == true) then
		return
	end
	if (player.mbeffect3_1 == true) then
		P_SetObjectMomZ(player.sprk3mb, 2*FRACUNIT, false)
	end
end

addHook("PlayerThink", magiceffect3_1)

local function magiceffect3_2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect3_1 == true) then
		return
	end
	if (player.mbeffect3_2 == true) then
		A_HomingChase(player.sprk3mb, 24*FRACUNIT)
	end
end

addHook("PlayerThink", magiceffect3_2)

local function magiceffect3_1and3_2dead(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect3_1 == true) then
		return
	end
	if (player.mbeffect3_2 == false) then
		return
	end
	local sprkdist = FixedMul(8*FRACUNIT, player.mo.scale)
	if (P_AproxDistance(P_AproxDistance(player.mo.x-player.sprk3mb.x, player.mo.y-player.sprk3mb.y), player.mo.z-player.sprk3mb.z) < sprkdist)
		P_KillMobj(player.sprk3mb)
		player.sprk3mb = nil
		player.mbeffect3_1 = false
		player.mbeffect3_2 = false
	end
end

addHook("PlayerThink", magiceffect3_1and3_2dead)

local function magiceffect3_2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.mbeffect3_2 == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mbeffect3_1 == false) then
		return
	end
	if (player.mbef3timer == nil) then
		player.mbef3timer = 0
	end

	player.mbef3timer = $1 + 1

	if (player.mbef3timer == 2*TICRATE) then
		player.sprk3mb.target = player.mo
		player.mbeffect3_2 = true
		player.mbeffect3_1 = false
		player.mbef3timer = nil
	end
end

addHook("PlayerThink", magiceffect3_2)

local function mbeffect3(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingmbp == false) then
		return
	end
	if (player.mbef4timer == nil) then
		player.mbef4timer = 0
	end

	player.mbef4timer = $1 + 1

	if (player.mbef4timer == 1*TICRATE/5) then
		local sprk = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPALTSPARKLE)
		sprk.color = SKINCOLOR_YELLOW
		player.mbef4timer = nil
	end
end

addHook("PlayerThink", mbeffect3)

-- Magic explosion in ground --

local function proyectiledead(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingmbp == true) then
		if (P_IsObjectOnGround(player.MGBRPR) and player.youhave1pyect == false and player.youhave2pyect == false and player.youhave3pyect == true) then
			local mbtardis = FixedMul(192*FRACUNIT, player.mo.scale)
			player.youhave1pyect = false
			player.youhave2pyect = true
			player.youhave3pyect = false
			player.mbtarget1 = P_LookForEnemies(player, true, true)
			player.mbtarget2 = P_LookForEnemies(player, true, true)
			player.mbtarget3 = P_LookForEnemies(player, true, true)
			player.ring1 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			player.ring2 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			local sprk1 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_YELLOW
			local sprk2 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_YELLOW
			local sprk3 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_YELLOW
			local sprk4 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_YELLOW
			local sprk5 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_YELLOW
			local sprk6 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_YELLOW
			local sprk7 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_YELLOW
			local sprk8 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_YELLOW
			if (player.mbtarget1 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget1.x, player.MGBRPR.y-player.mbtarget1.y), player.MGBRPR.z-player.mbtarget1.z) < mbtardis) and (player.mbtarget1 and player.mbtarget1.valid) then
				P_DamageMobj(player.mbtarget1 , player.mo, player.mo, 1)
				player.mbtarget1 = nil
				player.mbtarget2 = P_LookForEnemies(player, true, true)
				player.mbtarget3 = P_LookForEnemies(player, true, true)
			end
			if (player.mbtarget2 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget2.x, player.MGBRPR.y-player.mbtarget2.y), player.MGBRPR.z-player.mbtarget2.z) < mbtardis) and (player.mbtarget2 and player.mbtarget2.valid) then
				P_DamageMobj(player.mbtarget2, player.mo, player.mo, 1)
				player.mbtarget2 = nil
				player.mbtarget3 = P_LookForEnemies(player, true, true)
			end
			if (player.mbtarget3 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget3.x, player.MGBRPR.y-player.mbtarget3.y), player.MGBRPR.z-player.mbtarget3.z) < mbtardis) and (player.mbtarget3 and player.mbtarget3.valid) then
				P_DamageMobj(player.mbtarget3, player.mo, player.mo, 1)
				player.mbtarget3 = nil
			end
			P_KillMobj(player.MGBRPR)
			player.usingmbp = false
			return
		end
		if (P_IsObjectOnGround(player.MGBRPR) and player.youhave1pyect == false and player.youhave2pyect == true and player.youhave3pyect == false) then
			local mbtardis = FixedMul(192*FRACUNIT, player.mo.scale)
			player.youhave1pyect = true
			player.youhave2pyect = false
			player.youhave3pyect = false
			player.mbtarget1 = P_LookForEnemies(player, true, true)
			player.mbtarget2 = P_LookForEnemies(player, true, true)
			player.mbtarget3 = P_LookForEnemies(player, true, true)
			player.ring1 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			player.ring2 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			local sprk1 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_YELLOW
			local sprk2 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_YELLOW
			local sprk3 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_YELLOW
			local sprk4 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_YELLOW
			local sprk5 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_YELLOW
			local sprk6 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_YELLOW
			local sprk7 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_YELLOW
			local sprk8 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_YELLOW
			if (player.mbtarget1 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget1.x, player.MGBRPR.y-player.mbtarget1.y), player.MGBRPR.z-player.mbtarget1.z) < mbtardis) and (player.mbtarget1 and player.mbtarget1.valid) then
				P_DamageMobj(player.mbtarget1 , player.mo, player.mo, 1)
				player.mbtarget1 = nil
				player.mbtarget2 = P_LookForEnemies(player, true, true)
				player.mbtarget3 = P_LookForEnemies(player, true, true)
			end
			if (player.mbtarget2 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget2.x, player.MGBRPR.y-player.mbtarget2.y), player.MGBRPR.z-player.mbtarget2.z) < mbtardis) and (player.mbtarget2 and player.mbtarget2.valid) then
				P_DamageMobj(player.mbtarget2, player.mo, player.mo, 1)
				player.mbtarget2 = nil
				player.mbtarget3 = P_LookForEnemies(player, true, true)
			end
			if (player.mbtarget3 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget3.x, player.MGBRPR.y-player.mbtarget3.y), player.MGBRPR.z-player.mbtarget3.z) < mbtardis) and (player.mbtarget3 and player.mbtarget3.valid) then
				P_DamageMobj(player.mbtarget3, player.mo, player.mo, 1)
				player.mbtarget3 = nil
			end
			P_KillMobj(player.MGBRPR)
			player.usingmbp = false
			return
		end
		if (P_IsObjectOnGround(player.MGBRPR) and player.youhave1pyect == true and player.youhave2pyect == false and player.youhave3pyect == false) then
			local mbtardis = FixedMul(192*FRACUNIT, player.mo.scale)
			player.youhave1pyect = false
			player.youhave2pyect = false
			player.youhave3pyect = false
			player.mbtarget1 = P_LookForEnemies(player, true, true)
			player.mbtarget2 = P_LookForEnemies(player, true, true)
			player.mbtarget3 = P_LookForEnemies(player, true, true)
			player.ring1 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			player.ring2 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			local sprk1 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_YELLOW
			local sprk2 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_YELLOW
			local sprk3 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_YELLOW
			local sprk4 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_YELLOW
			local sprk5 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_YELLOW
			local sprk6 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_YELLOW
			local sprk7 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_YELLOW
			local sprk8 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_YELLOW
			if (player.mbtarget1 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget1.x, player.MGBRPR.y-player.mbtarget1.y), player.MGBRPR.z-player.mbtarget1.z) < mbtardis) and (player.mbtarget1 and player.mbtarget1.valid) then
				P_DamageMobj(player.mbtarget1 , player.mo, player.mo, 1)
				player.mbtarget1 = nil
				player.mbtarget2 = P_LookForEnemies(player, true, true)
				player.mbtarget3 = P_LookForEnemies(player, true, true)
			end
			if (player.mbtarget2 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget2.x, player.MGBRPR.y-player.mbtarget2.y), player.MGBRPR.z-player.mbtarget2.z) < mbtardis) and (player.mbtarget2 and player.mbtarget2.valid) then
				P_DamageMobj(player.mbtarget2, player.mo, player.mo, 1)
				player.mbtarget2 = nil
				player.mbtarget3 = P_LookForEnemies(player, true, true)
			end
			if (player.mbtarget3 ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtarget3.x, player.MGBRPR.y-player.mbtarget3.y), player.MGBRPR.z-player.mbtarget3.z) < mbtardis) and (player.mbtarget3 and player.mbtarget3.valid) then
				P_DamageMobj(player.mbtarget3, player.mo, player.mo, 1)
				player.mbtarget3 = nil
			end
			P_KillMobj(player.MGBRPR)
			player.usingmbp = false
			return
		end
	end
end

addHook("PlayerThink", proyectiledead)

-- Magic explosion in air --

local function proyectiledeadinair(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingmbp == true) then
		player.mbtargetair = P_LookForEnemies(player, true, true)
		local airtardis = FixedMul(64*FRACUNIT, player.mo.scale)
		if (player.mbtargetair ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtargetair.x, player.MGBRPR.y-player.mbtargetair.y), player.MGBRPR.z-player.mbtargetair.z) < airtardis) and (player.mbtargetair and player.mbtargetair.valid and player.youhave1pyect == false and player.youhave2pyect == false and player.youhave3pyect == true) then
			player.youhave1pyect = false
			player.youhave2pyect = true
			player.youhave3pyect = false
			player.ring1 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			player.ring2 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			P_DamageMobj(player.mbtargetair, player.mo, player.mo, 1)
			player.mbtargetair = nil
			local sprk1 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_YELLOW
			local sprk2 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_YELLOW
			local sprk3 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_YELLOW
			local sprk4 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_YELLOW
			local sprk5 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_YELLOW
			local sprk6 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_YELLOW
			local sprk7 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_YELLOW
			local sprk8 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_YELLOW
			P_KillMobj(player.MGBRPR)
			player.usingmbp = false
			return
		end
		if (player.mbtargetair ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtargetair.x, player.MGBRPR.y-player.mbtargetair.y), player.MGBRPR.z-player.mbtargetair.z) < airtardis) and (player.mbtargetair and player.mbtargetair.valid and player.youhave1pyect == false and player.youhave2pyect == true and player.youhave3pyect == false) then
			player.youhave1pyect = true
			player.youhave2pyect = false
			player.youhave3pyect = false
			player.ring1 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			player.ring2 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			P_DamageMobj(player.mbtargetair, player.mo, player.mo, 1)
			player.mbtargetair = nil
			local sprk1 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_YELLOW
			local sprk2 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_YELLOW
			local sprk3 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_YELLOW
			local sprk4 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_YELLOW
			local sprk5 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_YELLOW
			local sprk6 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_YELLOW
			local sprk7 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_YELLOW
			local sprk8 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_YELLOW
			P_KillMobj(player.MGBRPR)
			player.usingmbp = false
			return
		end
		if (player.mbtargetair ~= nil) and (P_AproxDistance(P_AproxDistance(player.MGBRPR.x-player.mbtargetair.x, player.MGBRPR.y-player.mbtargetair.y), player.MGBRPR.z-player.mbtargetair.z) < airtardis) and (player.mbtargetair and player.mbtargetair.valid and player.youhave1pyect == true and player.youhave2pyect == false and player.youhave3pyect == false) then
			player.youhave1pyect = false
			player.youhave2pyect = false
			player.youhave3pyect = false
			player.ring1 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			player.ring2 = P_SpawnMobjFromMobj(player.MGBRPR, P_RandomRange(48, -48)*FRACUNIT, P_RandomRange(48, -48)*FRACUNIT, 8*FRACUNIT, MT_RING)
			P_DamageMobj(player.mbtargetair, player.mo, player.mo, 1)
			player.mbtargetair = nil
			local sprk1 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk1.color = SKINCOLOR_YELLOW
			local sprk2 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk2.color = SKINCOLOR_YELLOW
			local sprk3 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk3.color = SKINCOLOR_YELLOW
			local sprk4 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk4.color = SKINCOLOR_YELLOW
			local sprk5 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk5.color = SKINCOLOR_YELLOW
			local sprk6 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk6.color = SKINCOLOR_YELLOW
			local sprk7 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk7.color = SKINCOLOR_YELLOW
			local sprk8 = P_SpawnMobjFromMobj(player.MGBRPR, 0, 0, 0, MT_SPSPARKLE)
			sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
			sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
			sprk8.color = SKINCOLOR_YELLOW
			P_KillMobj(player.MGBRPR)
			player.usingmbp = false
			return
		end
	end
end

addHook("PlayerThink", proyectiledeadinair)

-- Magic movement xd --

local function magicproyectile(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingmbp == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.youhave1pyect == false and player.youhave2pyect == false and player.youhave3pyect == false) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.cmd.buttons&BT_FIRENORMAL) then
		if not player.pressedfnrml
		player.MGBRPR = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_MAGICPROYECTILE)
		player.mbtarget1 = P_LookForEnemies(player, true, true)
		player.mbtarget2 = P_LookForEnemies(player, true, true)
		player.mbtarget3 = P_LookForEnemies(player, true, true)
		P_InstaThrust(player.MGBRPR, player.mo.angle, player.speed+6*FRACUNIT/4)
		if (player.mo.eflags&MFE_VERTICALFLIP) then
			player.MGBRPR.eflags = $1|MFE_VERTICALFLIP	
		end
		P_SetObjectMomZ(player.MGBRPR, 12*FRACUNIT, false)
		player.usingmbp = true
	end
		player.pressedfnrml = true
	else
		player.pressedfnrml = false
	end
end

addHook("PlayerThink", magicproyectile)

-- Get MB charges --

local function magicbracalet(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (gametype == GT_MATCH) then
		return
	end
	if (gametype == GT_TEAMMATCH) then
		return
	end
	if (gametype == GT_TAG) then
		return
	end
	if (gametype == GT_HIDEANDSEEK) then
		return
	end
	if (gametype == GT_CTF) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.youhave3pyect == true) then
		return
	end
	if not P_IsObjectOnGround(player.mo) then
		return
	end
	local tardist = FixedMul(200*FRACUNIT, player.mo.scale)
	player.mbtarget = P_LookForEnemies(player, false, true)
	if (player.cmd.buttons&BT_TOSSFLAG) then
		if not player.pressedflg
		if (player.mbtarget and player.mbtarget.valid and player.mbtarget.health <= 1) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.mbtarget.x, player.mo.y-player.mbtarget.y), player.mo.z-player.mbtarget.z) < tardist) and (player.mbtarget and player.mbtarget.valid) then
			P_DamageMobj(player.mbtarget, player.mo, player.mo, 1)
			if (player.sprk2mb ~= nil) then
				player.sprk3mb = P_SpawnMobjFromMobj(player.mbtarget, 0, 0, 0, MT_SPINFSPARKLE)
				player.sprk3mb.color = SKINCOLOR_YELLOW
				player.mbeffect3_1 = true
				player.mbeffect3_2 = false
			end
			if (player.sprk1mb ~= nil) then
				player.sprk2mb = P_SpawnMobjFromMobj(player.mbtarget, 0, 0, 0, MT_SPINFSPARKLE)
				player.sprk2mb.color = SKINCOLOR_YELLOW
				player.mbeffect2_1 = true
				player.mbeffect2_2 = false
			end
			if (player.sprk1mb == nil) then
				player.sprk1mb = P_SpawnMobjFromMobj(player.mbtarget, 0, 0, 0, MT_SPINFSPARKLE)
				player.sprk1mb.color = SKINCOLOR_YELLOW
				player.mbeffect1_1 = true
				player.mbeffect1_2 = false
			end
		end
		if (player.mbtarget ~= nil) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.mbtarget.x, player.mo.y-player.mbtarget.y), player.mo.z-player.mbtarget.z) < tardist) and (player.mbtarget and player.mbtarget.valid and player.youhave1pyect == false and player.youhave2pyect == true and player.youhave3pyect == false) then
			player.youhave1pyect = false
			player.youhave2pyect = false
			player.youhave3pyect = true
		end
		if (player.mbtarget ~= nil) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.mbtarget.x, player.mo.y-player.mbtarget.y), player.mo.z-player.mbtarget.z) < tardist) and (player.mbtarget and player.mbtarget.valid and player.youhave1pyect == true and player.youhave2pyect == false and player.youhave3pyect == false) then
			player.youhave1pyect = false
			player.youhave2pyect = true
			player.youhave3pyect = false
		end
		if (player.mbtarget ~= nil) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.mbtarget.x, player.mo.y-player.mbtarget.y), player.mo.z-player.mbtarget.z) < tardist) and (player.mbtarget and player.mbtarget.valid and player.youhave1pyect == false and player.youhave2pyect == false and player.youhave3pyect == false) then
			player.youhave1pyect = true
			player.youhave2pyect = false
			player.youhave3pyect = false
		end
	end
		player.pressedflg = true
	else
		player.pressedflg = false
	end
end 

addHook("PlayerThink", magicbracalet)

-- INSTA-STOP --

-- In the ground --

local function instastopnoair(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	S_StartSound(player.mo, sfx_insstp)
	P_InstaThrust (player.mo, player.mo.angle, 0*FRACUNIT)
	local ghst = P_SpawnGhostMobj(player.mo)
	player.bjauraeffect = false
	player.mo.state = S_PLAY_STND
end

local function c2instastop1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if  (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.speed < 32*FRACUNIT) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canuseisairs == false) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.drawc3options == true) then
		return
	end
	if (player.usingboost == true and player.midjump == false) then
		return
	end
	if (player.cmd.buttons & BT_CUSTOM2) then
		if not player.pressedcustom2
		instastopnoair(player)
	end
		player.pressedcustom2 = true
	else
		player.pressedcustom2 = false
	end
end

addHook("PlayerThink", c2instastop1)

-- To do in air --

local function forceisairoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.momz > 0) or (player.panim ~= PA_FALL) then
		player.usingisair = false
		player.usedisair = false
	end
end

addHook("PlayerThink", forceisairoff)

local function usedisairreset(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_IsObjectOnGround(player.mo) then
		player.usedisair = false
		player.usingisair = false
	end
end

addHook("PlayerThink", usedisairreset)

local function instastopair(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.pflags&PF_THOKKED) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingisair == true) then
		player.bjtimer = nil
		player.bjauraeffect = false
		player.canusepeel = true
		player.allowtrick = false
		if (player.pflags&PF_JUMPED) then
			player.pflags = $1&~PF_JUMPED
		end
		player.usedisair = true
		player.usingisair = true
		player.blockallabilities = true
	end
end

addHook("PlayerThink", instastopair)

local function c2instastop2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if  (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.drawc3options == true) then
		return
	end
	if (player.canuseisairs == false) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM2  and player.pflags&PF_JUMPED) then
		if not player.pressedcustom2
		player.usedshield = true
		player.wtimer = nil
		player.usingws = false
		player.mo.state = S_PLAY_FALL
		S_StartSound(player.mo, sfx_insstp)
		local ghst = P_SpawnGhostMobj(player.mo)
		P_InstaThrust (player.mo, player.mo.angle, 0*FRACUNIT)
		player.mo.momz = 0*FRACUNIT
		player.mo.state = S_PLAY_FALL
		player.usingisair = true
		instastopair(player)
		if (player.usingboost == true)
			player.usingboost = false
			player.usingdash = false
			player.btimer = nil
			S_StopSoundByID(player.mo, sfx_bostw)
		end
	end
		player.pressedcustom2 = true
	else
		player.pressedcustom2 = false
	end
end

addHook("PlayerThink", c2instastop2)

-- LIGHT DASH --

-- Desactivate Timer 2 ... yes xd --

local function desactivatelightcarge(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.cmd.buttons&BT_SPIN) then
		player.ldtimer = nil
	end
end

addHook("PlayerThink", desactivatelightcarge)

-- Desactivate Light Dash Timer --

local function lightdashtimeroff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usedlightdash == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usinglightdash == false) then
		return
	end
	if (player.lotimer == nil) then
		player.lotimer = 0
		end

	player.lotimer = $1 + 1

	if (player.lotimer == 1*TICRATE) then
		player.usinglightdash = false
		player.blockringrefill = false
		player.soundlighttimer = nil
		S_StopSoundByID(player.mo, sfx_lightm)
		S_StopSoundByID(player.mo, sfx_lightm)
		player.mo.momz = 0*FRACUNIT
		player.mo.momx = 0*FRACUNIT
		player.mo.momy = 0*FRACUNIT
		player.lotimer = nil
		if (player.midjump == false) then
			player.mo.state = S_PLAY_STND
		else
			player.mo.state = S_PLAY_FALL
		end
	end
end

addHook("PlayerThink", lightdashtimeroff)

-- The timer --

local function lightdashtimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if not (player.pflags&PF_STARTDASH) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.ringenergy < 4) then
		return
	end
	if (player.ldtimer == nil) then
		player.ldtimer = 0
		end

	player.ldtimer = $1 + 1

	if (player.ldtimer == 3*TICRATE) then
		player.pflags = $&~PF_STARTDASH&~PF_SPINNING
		S_StartSound(player.mo, sfx_spbson)
		player.mo.state = S_PLAY_STND
		player.activatelightdash = true
		player.lightdashlight = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSONICLIGHT)
		player.lightdashlight.target = player.mo
		player.usedlightdash = false
		player.blockallabilities = false
		player.ldtimer = nil
		player.ldstimer = nil
		player.ultimer = nil
		player.lotimer = nil
		player.blockringrefill = true
		player.mo.colorized = true
	end
end

addHook("PlayerThink", lightdashtimer)

-- Light Dash movement (Without target) --

local function lightdashmovement(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingisair == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usinglightdash == true) then
		detectrings(player)
		S_StartSound(player.mo, sfx_lightm)
		player.invisiframe = 1*TICRATE
		if (player.powers[pw_super]) then
			player.mo.state = S_PLAY_RUN
		else
			player.mo.state = S_PLAY_LIGHTDASH1
		end		
		player.mo.momz = 0*FRACUNIT
		if (player.usedlightdash == false) then
			player.lightrings = player.rings
		end
		player.blockringrefill = true
		local ghs = P_SpawnGhostMobj(player.mo)
		ghs.fuse = 4
		if (player.usedlightdash == false) then
			P_InstaThrust (player.mo, player.mo.angle, 64*FRACUNIT)
		else
			P_InstaThrust (player.mo, player.mo.angle, 16*FRACUNIT)
		end
		SmoothTrail(player.mo, MT_BTHOK, 8*FRACUNIT, player.mo.color)
		local sprk = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPALTSPARKLE)
		sprk.momx = P_RandomRange(4, -4)*FRACUNIT
		sprk.momy = P_RandomRange(4, -4)*FRACUNIT
		sprk.momz = P_RandomRange(4, -4)*FRACUNIT
		sprk.color = player.mo.color
		local enemydist = FixedMul(192*FRACUNIT, player.mo.scale)
		player.ldetarget1 = P_LookForEnemies(player, false, true)
		if (player.ldetarget1 and player.ldetarget1.valid) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.ldetarget1.x, player.mo.y-player.ldetarget1.y), player.mo.z-player.ldetarget1.z) < enemydist) then
			P_DamageMobj(player.ldetarget1, player.mo, player.mo, 1)
			player.ldetarget1 = nil
			player.ldetarget2 = P_LookForEnemies(player, false, true)
			player.ldetarget3 = P_LookForEnemies(player, false, true)
		end
		if (player.ldetarget2 and player.ldetarget2.valid) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.ldetarget2.x, player.mo.y-player.ldetarget2.y), player.mo.z-player.ldetarget2.z) < enemydist) then
			P_DamageMobj(player.ldetarget2, player.mo, player.mo, 1)
			player.ldetarget2 = nil
			player.ldetarget3 = P_LookForEnemies(player, false, true)
		end
		if (player.ldetarget3 and player.ldetarget3.valid) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.ldetarget3.x, player.mo.y-player.ldetarget3.y), player.mo.z-player.ldetarget3.z) < enemydist) then
			P_DamageMobj(player.ldetarget3, player.mo, player.mo, 1)
			player.ldetarget3 = nil
		end
		if (player.pflags&PF_ANALOGMODE and player.usedlightdash == false) then
			return
		end
		if (player.mo.flags2&MF2_TWOD) then
			return
		end
		if (twodlevel) then
			return
		end
		player.drawangle = camera.angle
		player.mo.angle = camera.angle
	end
end

addHook("PlayerThink", lightdashmovement)

-- Another Light Dash Timer --

local function usedlighttimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedlightdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.ultimer == nil) then
		player.ultimer = 0
		end

	player.ultimer = $1 + 1

	if (player.ultimer == 1*TICRATE/5) then
		player.usinglightdash = false
		player.mo.momz = 0*FRACUNIT
		player.mo.momx = 0*FRACUNIT
		player.mo.momy = 0*FRACUNIT
		player.mo.z = $1 + 2*FRACUNIT
		player.mo.state = S_PLAY_FALL
		player.usedlightdash = false
		player.blockringrefill = false
		player.ultimer = nil
		player.lotimer = nil
		player.soundlighttimer = nil
		S_StopSoundByID(player.mo, sfx_lightm)
		S_StopSoundByID(player.mo, sfx_lightm)
		local gsht = P_SpawnGhostMobj(player.mo)
		gsht.colorized = true
	end
end

addHook("PlayerThink", usedlighttimer)

-- The Light Dash --

local function dothelightdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	local targetdistance = FixedMul(200*FRACUNIT, player.mo.scale)

	if (player.ringtarget == nil) then
		return
	end
	if (player.usingisair == true) then
		return
	end
	if (player.usinglightdash == false) then
		return
	end
	player.lddist = P_AproxDistance(P_AproxDistance(player.mo.x-player.ringtarget.x, player.mo.y-player.ringtarget.y), player.mo.z-player.ringtarget.z)
	if (player.lddist < 1) then
		player.lddist = 1
	end
	player.mo.momx = FixedMul(FixedDiv(player.ringtarget.x-player.mo.x, player.lddist), 60*FRACUNIT)
	player.mo.momy = FixedMul(FixedDiv(player.ringtarget.y-player.mo.y, player.lddist), 60*FRACUNIT)
	player.mo.momz = FixedMul(FixedDiv(player.ringtarget.z-player.mo.z, player.lddist), 60*FRACUNIT)
	player.drawangle = R_PointToAngle2(player.mo.x,player.mo.y,player.ringtarget.x,player.ringtarget.y)
	camera.momx = 0
	camera.momy = 0
	player.invisiframe = 1*TICRATE
	player.stunlighttimer = nil
	player.mo.state = S_PLAY_LIGHTDASH1
	player.blockringrefill = true
	player.usedlightdash = true
	player.ultimer = nil
	player.lotimer = nil
	if (player.lightrings < player.rings) then
		S_StartSound(player.mo, sfx_lightg)
		player.lightrings = player.rings
		if (player.ringenergy < 80) then
			player.ringenergy = $1 + 4
		end
	end
end

addHook("PlayerThink", dothelightdash)

-- Stun --

local function stunlight(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usinglightdash == false) then
		return
	end
	if (player.usedlightdash == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.stunlighttimer == nil) then
		player.stunlighttimer = 0
	end

	player.stunlighttimer = $1 + 1

	if (player.stunlighttimer > 1*TICRATE/8) then
		if (player.speed < 24*FRACUNIT) then
			player.mo.state = S_PLAY_PAIN
			S_StartSound(player.mo, sfx_crnc)
			P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
			P_InstaThrust(player.mo, player.mo.angle, -12*FRACUNIT)
			player.usinglightdash = false
			player.ultimer = nil
			player.lotimer = nil
			player.activatelightdash = false
			player.blockringrefill = false
			player.usedlightdash = false
			player.soundlighttimer = nil
			S_StopSoundByID(player.mo, sfx_lightm)
			S_StopSoundByID(player.mo, sfx_lightm)
			S_StopSoundByID(player.mo, sfx_lightm)
			player.stunlighttimer = nil
		end
	end
end

addHook("PlayerThink", stunlight)

-- Use Light Dash --

local function uselightdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.activatelightdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.ringenergy < 4 and not player.powers[pw_super]) then
		player.activatelightdash = false
		return
	end
	if not (player.cmd.buttons&BT_SPIN) then
		player.ultimer = nil
		player.mo.z = player.mo.z+8*FRACUNIT
		player.mo.state = S_PLAY_LIGHTDASH1
		local ghst = P_SpawnGhostMobj(player.mo)
		ghst.scale = 2*FRACUNIT
		ghst.colorized = true
		S_StartSound(player.mo, sfx_lightr)
		P_KillMobj(player.lightdashlight)
		player.lightlastangle = player.mo.angle
		player.usinglightdash = true
		player.blockringrefill = true
		player.ringenergy = $1 - 4
		player.stunlighttimer = nil
		player.normalspeed = 36*FRACUNIT
		player.activatelightdash = false
		player.mo.colorized = false
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
	end
end

addHook("PlayerThink", uselightdash)

-- cancel light dash --

local function cancellightdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usinglightdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM2) then
		if not player.pressedcustom2
		P_InstaThrust (player.mo, player.mo.angle, 0*FRACUNIT)
		player.mo.momz = 0*FRACUNIT
		player.usingisair = true
		player.usinglightdash = false
		player.ultimer = nil
		player.lotimer = nil
		player.activatelightdash = false
		player.blockringrefill = false
		player.usedlightdash = false
		instastopair(player)
	end
		player.pressedcustom2 = true
	else
		player.pressedcustom2 = false
	end
end

addHook("PlayerThink", cancellightdash)

-- cancel spin --

local function blockspin(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.activatelightdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		player.pflags = $1&~PF_SPINNING
		player.mo.state = S_PLAY_WALK
	end
end

addHook("PlayerThink", blockspin)

-- HOMING ATTACK --

-- Spring Bug --

local function springbugresolvexd(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim == PA_SPRING) then
		player.usinghomingattack = false
		player.usedhomingattack = false
		player.usestopp = false
		player.homingtarget = nil
		player.blockallabilities = false
		player.stpplayer = false
		player.htimer = nil
		player.allowtrick = false
	end
end

addHook("PlayerThink", springbugresolvexd)

-- Search A Enemy, Monitor, Spring and Bosses --

local function homingtarget(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usinghomingattack == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canusehoming == false) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.usedhomingattack == false) then
		player.homingtarget = P_LookForEnemies(player, true, false)
		if (player.homingtarget and player.homingtarget.flags&MF_BOSS and player.powers[pw_shield] ~= SH_ATTRACT) then
			player.homingtarget = nil
			return
		end
		player.lock = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_LOCKON)
		player.lock.target = player.homingtarget
		player.lock.tracer = player.mo
	end
end

addHook("PlayerThink", homingtarget)

-- Timer --

local function homingtimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedhomingattack == false) then
		return
	end
	if (player.startresethomingtimer == false) then
		return
	end
	if (player.htimer == nil) then
		player.htimer = 0
		end

	player.htimer = $1 + 1

	if (player.htimer > 1*TICRATE/5) then
		player.startresethomingtimer = false
		player.blockallabilities = false
		player.usedhomingattack = false
		player.usinghomingattack = false
		player.homingtarget = nil
		player.htimer = nil
	end
end

addHook("PlayerThink", homingtimer)

-- Thok Effect --

local function homingeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.panim&PA_PAIN) then
		return
	end
	if (player.usedhomingattack == true) then
		SmoothTrail(player.mo, MT_BTHOK, 8*FRACUNIT, player.mo.color)
	end
end

addHook("PlayerThink", homingeffect)

local function stopplayer(player)
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usestopp == false) then
		return
	end
	if (player.stpplayer == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	player.mo.momx = 0
	player.mo.momy = 0
	player.stpplayer = true
end

-- Tricks --

local function trick1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.blockallabilities == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.allowtrick == false) then
		return
	end
	if not (player.lasttarget and player.lasttarget.valid) then
		return
	end
	if (player.lasttarget.health == player.lasttargethealth-1) then
		player.usestopp = true
		player.homindjumptimer = nil
		P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
		stopplayer(player)
		player.mo.state = S_PLAY_FALL
		player.usinghomingattack = false
		player.lasttarget = nil
		player.lasttargethealth = nil
		player.startresethomingtimer = true
		player.blockhomingjumptimer = false
		player.homindjumptimer2 = nil
		player.homed = false
		player.useeffecttrick = true
	end
end

addHook("PlayerThink", trick1)

local function trick2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.allowtrick == true and player.mo.momz < 1*FRACUNIT and player.panim == PA_FALL and player.mo.eflags&~MFE_VERTICALFLIP) then
		player.mo.state = S_PLAY_JUMP
		player.useeffecttrick = false
		player.usestopp = false
		player.allowtrick = false
	end
	if (player.allowtrick == true and player.mo.momz > 1*FRACUNIT and player.panim == PA_FALL and player.mo.eflags&MFE_VERTICALFLIP) then
		player.mo.state = S_PLAY_JUMP
		player.useeffecttrick = false
		player.usestopp = false
		player.allowtrick = false
	end
end

addHook("PlayerThink", trick2)

local function usinghoming(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usinghomingattack == false) then
		return
	end
	if not (player.lasttarget and player.lasttarget.valid) then
		return
	end
	if (player.lasttarget.health == player.lasttargethealth-1) then
		player.homindjumptimer = nil
		player.homindjumptimer2 = nil
		player.homed = false
		return
	end
	local dist = FixedMul(64*FRACUNIT, player.mo.scale)
	if (player.homed) or (P_AproxDistance(player.mo.x-player.homingtarget.x, player.mo.y-player.homingtarget.y) < player.starthomingdist/2)
		player.mo.state = S_PLAY_JUMP
		local g = P_SpawnGhostMobj(player.mo)
		g.fuse = 6
		player.homed = true
		player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.homingtarget.x, player.homingtarget.y)
		player.hmdist = P_AproxDistance(P_AproxDistance(player.mo.x-player.homingtarget.x, player.mo.y-player.homingtarget.y), player.mo.z-player.homingtarget.z)
		player.mo.momx = FixedMul(FixedDiv(player.homingtarget.x-player.mo.x, player.hmdist), 48*FRACUNIT)
		if not (player.mo.flags2 & MF2_TWOD) then
			player.mo.momy = FixedMul(FixedDiv(player.homingtarget.y-player.mo.y, player.hmdist), 48*FRACUNIT)
		end
		if (player.homindjumptimer2 == nil) then
			player.homindjumptimer2 = 0
		end
		player.homindjumptimer2 = $1 + 1
		if not (player.homingtarget.flags&MF_SPRING) then
			player.mo.momz = FixedMul(FixedDiv((player.homingtarget.z+player.homingtarget.height)-(player.mo.z+player.mo.height), player.hmdist), player.homindjumptimer2*2*FRACUNIT)
		else
			player.mo.momz = FixedMul(FixedDiv((player.homingtarget.z+player.homingtarget.height)-(player.mo.z+player.mo.height), player.hmdist), 64*FRACUNIT)
			player.usinghomingattack = false
			player.usedhomingattack = false
			player.usestopp = false
			player.homingtarget = nil
			player.blockallabilities = false
			player.stpplayer = false
			player.htimer = nil
			player.allowtrick = false
			player.homindjumptimer = nil
			player.homindjumptimer2 = nil
			player.homed = false
		end
	else
		if (player.homindjumptimer == nil) then
			player.homindjumptimer = 0
		end
		player.homindjumptimer = $1 + 1
		P_SetObjectMomZ(player.mo, player.homindjumptimer*2*FRACUNIT, false)
		player.mo.state = S_PLAY_JUMP
		player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.homingtarget.x, player.homingtarget.y)
		player.hmdist = P_AproxDistance(P_AproxDistance(player.mo.x-player.homingtarget.x, player.mo.y-player.homingtarget.y), player.mo.z-player.homingtarget.z)
		player.mo.momx = FixedMul(FixedDiv(player.homingtarget.x-player.mo.x, player.hmdist), 48*FRACUNIT)
		local g = P_SpawnGhostMobj(player.mo)
		g.fuse = 8
		if not (player.mo.flags2 & MF2_TWOD) then
			player.mo.momy = FixedMul(FixedDiv(player.homingtarget.y-player.mo.y, player.hmdist), 48*FRACUNIT)
		end
	end
end

addHook("PlayerThink", usinghoming)

-- Activate Homing --

local function activatinghomingattack(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usinghomingattack == true) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.homingtarget == nil) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.cmd.buttons & BT_SPIN) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedhomingattack == true) then
		return
	end
	if (player.canusehoming == false) then
		return
	end
	if (player.walljumped == true) then
		return
	end
	if (player.canwalljump == true) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		S_StartSound(player.mo, sfx_thok)
		player.usedshield = false
		player.wtimer = nil
		player.usingws = false
		player.starthomingdist = P_AproxDistance(player.mo.x-player.homingtarget.x, player.mo.y-player.homingtarget.y)
		player.lasttarget = player.homingtarget
		player.lasttargethealth = player.homingtarget.health
		player.usinghomingattack = true
		player.usedhomingattack = true
		usinghoming(player)
		player.allowtrick = true
		player.usestopp = false
		player.stpplayer = false
		player.blockallabilities = true
	end
end

addHook("AbilitySpecial", activatinghomingattack)

-- INSTA-SHIELD --

local function instashield(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedis == true) then
		return
	end
	if (player.homingtarget ~= nil) then
		return
	end
	if (player.canusepdblst == true) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if not (player.powers[pw_shield] == SH_NONE) then
		return
	end
	if (player.powers[pw_invulnerability]) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.walljumped == true) then
		return
	end
	if (player.canwalljump == true) then
		return
	end
	S_StartSound(player.mo, sfx_s3k42)
	player.powers[pw_invulnerability] = 12
	local IS = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_INSTASHIELD)
		IS.color = player.mo.color
		IS.target = player.mo
		IS.fuse = 16
		if (player.mo.eflags&MFE_VERTICALFLIP) then
			IS.eflags = $1|MFE_VERTICALFLIP
		end
		player.usedis = true
		end

addHook("AbilitySpecial", instashield)

-- Combat Mode --

local function instabum(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	player.instatarget = P_LookForEnemies(player, false, false)

	if (player.usedib == true) then
		return
	end
	if not (player.powers[pw_shield] == SH_NONE) then
		return
	end
	if (player.instatarget == nil) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canusepdblst == true) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if not (P_AproxDistance(P_AproxDistance(player.mo.x-player.instatarget.x, player.mo.y-player.instatarget.y), player.mo.z-player.instatarget.z) < player.instatarget.radius+80*FRACUNIT) then
		player.instatarget = nil
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.walljumped == true) then
		return
	end
	if (player.canwalljump == true) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		player.allowtrick = false
		player.ringenergy = $1 + 4
		P_DamageMobj(player.instatarget, player.mo, player.mo, 2)
		S_StartSound(player.mo, sfx_kc3b)
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = SKINCOLOR_WHITE
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = SKINCOLOR_WHITE
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = SKINCOLOR_WHITE
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = SKINCOLOR_WHITE
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = SKINCOLOR_WHITE
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = SKINCOLOR_WHITE
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = SKINCOLOR_WHITE
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = SKINCOLOR_WHITE
		player.usedib = true
		player.mo.momx = 0
		player.mo.momy = 0
	end
end

addHook("AbilitySpecial", instabum)

-- Whirlwind Shield --

-- timer --

local function whirltimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingws == false) then
		return
	end
	if (player.usedshield == true) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.wtimer == nil) then
		player.wtimer = 0
		end
	
	player.wtimer = $1 + 1 

	if (player.wtimer == 1*TICRATE) then
		player.usedshield = true
		player.wtimer = nil
		player.usingws = false
	end
end

addHook("PlayerThink", whirltimer)

local function usingwhirlwind(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingws == true) then
		player.mo.momz = 0*FRACUNIT
	end
end

addHook("PlayerThink", usingwhirlwind)

local function spwhirlwind(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.canusepdblst == true) then
		return
	end
	if (player.usinghomingattack == true) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedis == true) then
		return
	end
	if (player.usedshield == true) then
		return
	end
	if (player.homingtarget ~= nil) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.powers[pw_shield] ~= SH_WHIRLWIND) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.walljumped == true) then
		return
	end
	if (player.canwalljump == true) then
		return
	end
	if (player.usingws == true)then
		return
	end
	S_StartSound(player.mo, sfx_kc68)
	player.usingws = true
end

addHook("AbilitySpecial", spwhirlwind)

-- Armageddon Shield --

local function sparmageddon(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedis == true) then
		return
	end
	if (player.homingtarget ~= nil) then
		return
	end
	if (player.canusepdblst == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usedshield == true) then
		return
	end
	if (player.panim == PA_FALL) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if not (player.powers[pw_shield] == SH_ARMAGEDDON) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.walljumped == true) then
		return
	end
	if (player.canwalljump == true) then
		return
	end
	player.usedshield = true
	P_BlackOw(player)
end

addHook("AbilitySpecial", sparmageddon)

-- RECULL --

-- To Reset Recull --

local function resetrecull(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_IsObjectOnGround(player.mo) then
		player.usedrecull = false
	end
end

addHook("PlayerThink", resetrecull)

-- The Recull --

local function recull(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if  (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.pflags&PF_JUMPED) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.activatelightdash == true) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.panim == PA_RIDE)  then
		return
	end
	if (player.panim == PA_ETC)  then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.reculltimer == nil) then
		player.reculltimer = 0
	end
	player.reculltimer = $1 + 1
	if (player.reculltimer >= 1*TICRATE/5 and player.cmd.buttons & BT_SPIN) then
		if not player.pressedspin
		P_SpawnGhostMobj(player.mo)
		S_StartSound(player.mo, sfx_3db16)
		player.mo.state = S_PLAY_JUMP
		player.dropsound = false
		player.pflags = $1|PF_JUMPED
		player.usedmj2 = false
		player.blockallabilities = false
		player.usedsecondarythok = false
		player.reculltimer = nil
		if not (player.powers[pw_super]) then
			player.blockdthok = true
			player.canusest = true
			player.usedrecull = true
		end
	end
		player.pressedspin = true
	else
		player.pressedspin = false
	end
end

addHook("PlayerThink", recull)

-- BOOST --

-- Effects --

addHook("MobjCollide", function(mob, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end
	local player = obj.player

	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.usingboost == true) then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if (mob.health < 1) then
		return
	end
	if not (mob.flags&MF_ENEMY or mob.flags&MF_MONITOR) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-mob.x, player.mo.y-mob.y), player.mo.z-mob.z) < spkdist) then
		if (player.mo.z >= mob.z-mob.height and player.mo.z <= mob.z+mob.height) then
			S_StartSound(player.mo, mob.info.deathsound)
			if mob.type == MT_YELLOWSHELL
				P_SpawnMobj(mob.x, mob.y,mob.z, MT_YELLOWSPRING)
			end
			P_KillMobj(mob, player.mo, player.mo)
			mob.health = 0
		end
	end
end, MT_NULL)

addHook("MobjCollide", function(mob, mob2)
	if not (mob2 and mob2.valid and mob2.type == MT_PLAYER) then
		return
	end

	local player = mob2.player

	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (mob.health < 1) then
		return
	end
	if not (mob.flags&MF_ENEMY or mob.flags&MF_MONITOR) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-mob.x, player.mo.y-mob.y), player.mo.z-mob.z) < spkdist) then
		if (player.mo.z >= mob.z-mob.height and player.mo.z <= mob.z+mob.height) then
			S_StartSound(player.mo, mob.info.deathsound)
			if mob.type == MT_YELLOWSHELL
				P_SpawnMobj(mob.x, mob.y,mob.z, MT_YELLOWSPRING)
			end
			P_KillMobj(mob, player.mo, player.mo)
			mob.health = 0
		end
	end
end, MT_NULL)

local function dashmodedust(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingboost == false) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags&MFE_TOUCHWATER) then
		return
	end
	local sprk = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk.scale = player.mo.scale*2/3
	sprk.momx = P_RandomRange(4, -4)*FRACUNIT
	sprk.momy = P_RandomRange(4, -4)*FRACUNIT
	sprk.momz = P_RandomRange(4, -4)*FRACUNIT
	sprk.color = player.mo.color
	if (player.mo.eflags&MFE_UNDERWATER) then
		local DMD1 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_SPINDUST)
		DMD1.momx = P_RandomRange(4, -4)*FRACUNIT
		DMD1.momy = P_RandomRange(4, -4)*FRACUNIT
		DMD1.state = S_SPINDUST_BUBBLE1
		DMD1.scale = player.mo.scale*2
		local DMD2 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_SPINDUST)
		DMD2.momx = P_RandomRange(4, -4)*FRACUNIT
		DMD2.momy = P_RandomRange(4, -4)*FRACUNIT
		DMD2.state = S_SPINDUST_BUBBLE1
		DMD2.scale = player.mo.scale*2
		local DMD3 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_SPINDUST)
		DMD3.momx = P_RandomRange(4, -4)*FRACUNIT
		DMD3.momy = P_RandomRange(4, -4)*FRACUNIT
		DMD3.state = S_SPINDUST_BUBBLE1
		DMD3.scale = player.mo.scale*2
		local DMD4 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_SPINDUST)
		DMD4.momx = P_RandomRange(4, -4)*FRACUNIT
		DMD4.momy = P_RandomRange(4, -4)*FRACUNIT
		DMD4.state = S_SPINDUST_BUBBLE1
		DMD4.scale = player.mo.scale*2
		return
	end
	if not (player.powers[pw_shield] == SH_ELEMENTAL) then
		local DMD1 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_ANOTHERDUST)
		DMD1.momx = P_RandomRange(8, -8)*FRACUNIT
		DMD1.momy = P_RandomRange(8, -8)*FRACUNIT
		local DMD2 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_ANOTHERDUST)
		DMD2.momx = P_RandomRange(8, -8)*FRACUNIT
		DMD2.momy = P_RandomRange(8, -8)*FRACUNIT
		local DMD3 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_ANOTHERDUST)
		DMD3.momx = P_RandomRange(8, -8)*FRACUNIT
		DMD3.momy = P_RandomRange(8, -8)*FRACUNIT
		local DMD4 = P_SpawnMobjFromMobj(player.mo, 0, 0 , 2*FRACUNIT, MT_ANOTHERDUST)
		DMD4.momx = P_RandomRange(8, -8)*FRACUNIT
		DMD4.momy = P_RandomRange(8, -8)*FRACUNIT
	else
		P_ElementalFire(player)
		P_ElementalFire(player)
		P_ElementalFire(player)
		if (player.mo.eflags&MFE_UNDERWATER) then
			return
		end
		if (player.powers[pw_super]) then
			return
		end
		sprk.color = SKINCOLOR_KETCHUP
	end
end

addHook("PlayerThink", dashmodedust)

local function usingdasheffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.mo.eflags&MFE_TOUCHWATER) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == true) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.usingdash == true) then
		local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_SPINDUST)
		P_InstaThrust(dust1, player.mo.angle+P_RandomRange(40, -40)*ANG1, P_RandomRange(-4, 32)*FRACUNIT)
		local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_SPINDUST)
		P_InstaThrust(dust2, player.mo.angle+P_RandomRange(40, -40)*ANG1, P_RandomRange(-4, 32)*FRACUNIT)
		if (player.mo.eflags&MFE_UNDERWATER) then
			dust1.state = S_SPINDUST_BUBBLE1
			dust2.state = S_SPINDUST_BUBBLE1
		end
	end
end

addHook("PlayerThink", usingdasheffect)

local function dashanimationon(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingboost == false) then
		return
	end
	if (player.pflags&PF_JUMPED) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_PlayerInPain(player) then
		return
	end
	if (player.panim ~= PA_RUN) then
		return
	end
	
	if (player.panim == PA_DASH) then
		return
	end
	player.mo.state = S_PLAY_DASH
end

addHook("PlayerThink", dashanimationon)

local function sideeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingboost == false) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.mo.flags2&MF2_TWOD) then
		return
	end
	if (twodlevel) then
		return
	end
	if ((FixedAngle(player.cmd.angleturn-player.lastangleturn)/FRACUNIT) > 2) and ((FixedAngle(player.cmd.angleturn-player.lastangleturn)/FRACUNIT) < 90) or
	((FixedAngle(player.cmd.angleturn-player.lastangleturn)/FRACUNIT) < -2)	and ((FixedAngle(player.cmd.angleturn-player.lastangleturn)/FRACUNIT) > -90) then
		if not (S_SoundPlaying(player.mo,sfx_derpe2))
			S_StartSound(player.mo, sfx_derpe2)
		end
	end
	if (player.cmd.sidemove > 30) or
	(player.cmd.sidemove < -30) then
		if not (S_SoundPlaying(player.mo,sfx_derpe2))
			S_StartSound(player.mo, sfx_derpe2)
		end
	end
end

addHook("PlayerThink", sideeffect)

addHook("MobjCollide", function(spike, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end
	local player = obj.player

	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-spike.x, player.mo.y-spike.y), player.mo.z-spike.z) < spkdist) then
		if (player.mo.z >= spike.z-spike.height and player.mo.z <= spike.z+spike.height) then
			S_StartSound(player.mo, spike.info.deathsound)
			P_KillMobj(spike, player.mo, player.mo)
			spike.health = 0
		end
	end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end
	local player = obj.player

	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-spike.x, player.mo.y-spike.y), player.mo.z-spike.z) < spkdist) then
		if (player.mo.z >= spike.z-spike.height and player.mo.z <= spike.z+spike.height) then
			S_StartSound(player.mo, spike.info.deathsound)
			P_KillMobj(spike, player.mo, player.mo)
			spike.health = 0
		end
	end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end
	local player = obj.player

	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-spike.x, player.mo.y-spike.y), player.mo.z-spike.z) < spkdist) then
		if (player.mo.z >= spike.z-spike.height and player.mo.z <= spike.z+spike.height) then
			S_StartSound(player.mo, spike.info.deathsound)
			P_KillMobj(spike, player.mo, player.mo)
			spike.health = 0
		end
	end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end

	local player = obj.player
	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-spike.x, player.mo.y-spike.y), player.mo.z-spike.z) < spkdist) then
		if (player.mo.z >= spike.z-spike.height and player.mo.z <= spike.z+spike.height) then
			S_StartSound(player.mo, spike.info.deathsound)
			P_KillMobj(spike, player.mo, player.mo)
			spike.health = 0
		end
	end
end, MT_WALLSPIKE)

addHook("MobjCollide", function(spike, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end

	local player = obj.player
	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-spike.x, player.mo.y-spike.y), player.mo.z-spike.z) < spkdist) then
		if (player.mo.z >= spike.z-spike.height and player.mo.z <= spike.z+spike.height) then
			S_StartSound(player.mo, spike.info.deathsound)
			P_KillMobj(spike, player.mo, player.mo)
			spike.health = 0
		end
	end
end, MT_WALLSPIKE)

addHook("MobjCollide", function(spike, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end

	local player = obj.player
	if not (player.usingboost == true) then
		return
	end
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	local spkdist = FixedMul(264*FRACUNIT, player.mo.scale)

	if not (player.usingboost == true) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-spike.x, player.mo.y-spike.y), player.mo.z-spike.z) < spkdist) then
		if (player.mo.z >= spike.z-spike.height and player.mo.z <= spike.z+spike.height) then
			S_StartSound(player.mo, spike.info.deathsound)
			P_KillMobj(spike, player.mo, player.mo)
			spike.health = 0
		end
	end
end, MT_WALLSPIKE)

local function dashmodeeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingboost == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.powers[pw_shield] ~= SH_ELEMENTAL) or (player.powers[pw_shield] == SH_ELEMENTAL and player.mo.eflags&MFE_UNDERWATER) or (player.powers[pw_super]) then
		SmoothTrail(player.mo, MT_BTHOK, 8*FRACUNIT, player.mo.color)
		if not (S_SoundPlaying(player.mo,sfx_bostw))
			S_StartSound(player.mo, sfx_bostw)
		end
		local gost = P_SpawnGhostMobj(player.mo)
		if (player.colorbghoost == false) then
			gost.color = player.mo.color
			gost.fuse = 28
			gost.colorized = true
			gost.blendmode = AST_ADD
			player.colorbghoost = true
		else
			player.colorbghoost = false
		end
	end
	if (player.mo.eflags&MFE_UNDERWATER) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.powers[pw_shield] == SH_ELEMENTAL) then
		SmoothTrail(player.mo, MT_BTHOK, 16*FRACUNIT, SKINCOLOR_KETCHUP)
		if not (S_SoundPlaying(player.mo,sfx_bostw))
			S_StartSound(player.mo, sfx_bostw)
		end
		local ghs = P_SpawnGhostMobj(player.mo)
		ghs.fuse = 10
		ghs.colorized = true
		ghs.blendmode = AST_ADD
	end
end

addHook("PlayerThink", dashmodeeffect)

local function boostdirll(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingboost == false) then
		player.bstdrilltimer = nil
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.bstdrilltimer == nil) then
		player.bstdrilltimer = 0
	end
	player.bstdrilltimer = $1 + 1
	if (player.bstdrilltimer == 10) then
		player.ringenergy = $1 - 4
		player.bstdrilltimer = nil
	end
end

addHook("PlayerThink", boostdirll)

local function boostgeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingboost == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.bstgtimer == nil) then
		player.bstgtimer = 0
		end

	player.bstgtimer = $1 + 1
	
	if (player.bstgtimer >= 1*TICRATE/15) then
		if (player.mo.momz < -16) then
			return
		end
		if (player.mo.momz > 16) then
			return
		end
		local BSTEF = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BOOSTEFFECT)
		BSTEF.angle = player.mo.angle
		if (player.powers[pw_shield] ~= SH_ELEMENTAL) or (player.powers[pw_shield] == SH_ELEMENTAL and player.mo.eflags&MFE_UNDERWATER) or (player.powers[pw_super]) then
			BSTEF.color = player.mo.color
		end
		if (player.mo.eflags&MFE_UNDERWATER) then
			return
		end
		if (player.powers[pw_super]) then
			return
		end
		if (player.powers[pw_shield] == SH_ELEMENTAL) then
			BSTEF.color = SKINCOLOR_KETCHUP
		end
		player.bstgtimer = nil
	end
end

addHook("PlayerThink", boostgeffect)

-- Timer --

local function timerboostmode(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingdash == false) then
		player.btimer = nil
		return
	end
	if (player.usingboost == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.btimer == nil) then
		player.btimer = 0
		end

	player.btimer = $1 + 1
 
	if (player.btimer > 2*TICRATE) then
		S_StartSound(player.mo, sfx_bostex)
		local ghs = P_SpawnGhostMobj(player.mo)
		ghs.fuse = 50
		ghs.scale = 2*FRACUNIT
		ghs.color = player.mo.color
		ghs.colorized = true
		player.BSTP = P_SpawnMobjFromMobj (player.mo, 0*FRACUNIT, 0*FRACUNIT, 0*FRACUNIT, MT_BOOSTEXP2)
		P_Thrust(player.BSTP, player.mo.angle, -8*FRACUNIT)
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
		player.usingboost = true
		player.btimer = nil
	end
end

addHook("PlayerThink", timerboostmode)

-- movements (Up and Down) --

local function movementforwardbackward(player)
	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.cmd.forwardmove > 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 6*FRACUNIT)
	elseif (player.cmd.forwardmove < 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -6*FRACUNIT)
	end
	if (player.cmd.forwardmove > 0  and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 1*FRACUNIT/50)
	elseif (player.cmd.forwardmove < 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -1*FRACUNIT/50)
	end
	if (player.cmd.forwardmove > 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 12*FRACUNIT)
	elseif (player.cmd.forwardmove < 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -12*FRACUNIT)
	end
	if (player.cmd.forwardmove > 0  and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT/50)
	elseif (player.cmd.forwardmove < 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -2*FRACUNIT/50)
	end	
end

-- movements (Left and Right) --

local function movementside(player)

	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 6*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -6*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 1*FRACUNIT/50)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -1*FRACUNIT/50)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 1*FRACUNIT/5)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -1*FRACUNIT/50)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 1*FRACUNIT/4)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -1*FRACUNIT/50)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 12*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -12*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 4*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -4*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 4*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -4*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT/50)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT/50)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT/5)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT/50)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT/4)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT/50)
	end
end

-- movements (For analog's controls) --

local function movementanalog(player)
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 6*FRACUNIT)
	elseif (player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 1*FRACUNIT and not player.powers[pw_super])
	end
	if (player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 12*FRACUNIT)
	elseif (player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
	end
end

-- Starting Boost --

local function runningplus(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == true) then
		return
	end
	if (player.canuseboost == false) then
		return
	end
	if (player.speed < 29*FRACUNIT and player.canboostalt == true) then
		return
	end
	if (player.speed < 30*FRACUNIT and player.canboostalt == false) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM1 and player.canboostalt == false) or 
	(player.boostalt == true and player.canboostalt == true) then
		movementforwardbackward(player)
		movementside(player)
		movementanalog(player)
		player.usingdash = true
	end
end

addHook("PlayerThink", runningplus)

-- Boost limits --

local function boostlimits(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim == PA_RUN) or
	(player.panim == PA_JUMP) or
	(player.panim == PA_SPRING) or
	(player.panim == PA_FALL) or
	(player.panim == PA_ABILITY2) or
	(player.panim == PA_DASH) or
	(player.panim == PA_ROLL) then
		player.blimitants = false
	else
		player.blimitants = true
	end
end

addHook("PlayerThink", boostlimits)

-- Desactivate Boost --

local function runningplusoff3(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockc1cancel == true) then
		return
	end
	if not (player.cmd.buttons&BT_CUSTOM1) then
		player.usingdash = false
		player.btimer = nil
		player.bstdrilltimer = nil
	end
end

addHook("PlayerThink", runningplusoff3)

local function runningplusoff2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.mo.momz > 8*FRACUNIT) then
		return
	end
	if (player.speed < 16*FRACUNIT) then
		S_StopSoundByID(player.mo, sfx_bostw)
		if (player.panim == PA_DASH) then
			if (player.midjump == false) 
				if (player.speed == 0) then
					player.mo.state = S_PLAY_STND
				else
					player.mo.state = S_PLAY_WALK
				end
			else
				player.mo.state = S_PLAY_FALL
			end
		end
		player.usingboost = false
		player.usingdash = false
		player.bstdrilltimer = nil
		player.btimer = nil
		S_StopSoundByID(player.mo, sfx_bostw)
	end
end

addHook("PlayerThink", runningplusoff2)

local function runningplusoff2_5(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == false and player.usingdash == false) then
		return
	end
	if not (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.mo.momz < -8*FRACUNIT) then
		return
	end
	if (player.speed < 16*FRACUNIT) then
		S_StopSoundByID(player.mo, sfx_bostw)
		if (player.panim == PA_DASH) then
			if (player.midjump == false) 
				if (player.speed == 0) then
					player.mo.state = S_PLAY_STND
				else
					player.mo.state = S_PLAY_WALK
				end
			else
				player.mo.state = S_PLAY_FALL
			end
		end
		player.usingboost = false
		player.usingdash = false
		player.bstdrilltimer = nil
		player.btimer = nil
		S_StopSoundByID(player.mo, sfx_bostw)
	end
end

addHook("PlayerThink", runningplusoff2_5)

local function runningplusoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == false and player.usingdash == false) then
		return
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.mo.momz > 8*FRACUNIT) then
		return
	end
	if (player.blimitants == true) or
	(player.usingboost == true and player.speed < 38*FRACUNIT and player.speed > 25*FRACUNIT) then
		S_StopSoundByID(player.mo, sfx_bostw)
		player.usingboost = false
		player.usingdash = false
		player.btimer = nil
		player.bstdrilltimer = nil
		S_StopSoundByID(player.mo, sfx_bostw)
		if (player.midair == false and player.panim == PA_DASH) then
			player.mo.state = S_PLAY_RUN
		end
	end
end

addHook("PlayerThink", runningplusoff)

local function runningplusoff_5(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingboost == false and player.usingdash == false) then
		return
	end
	if not (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.mo.momz < -8*FRACUNIT) then
		return
	end
	if (player.blimitants == true) or
	(player.usingboost == true and player.speed < 38*FRACUNIT and player.speed > 25*FRACUNIT) then
		S_StopSoundByID(player.mo, sfx_bostw)
		player.usingboost = false
		player.usingdash = false
		player.btimer = nil
		player.bstdrilltimer = nil
		S_StopSoundByID(player.mo, sfx_bostw)
		if (player.midair == false and player.panim == PA_DASH) then
			player.mo.state = S_PLAY_RUN
		end
	end
end

addHook("PlayerThink", runningplusoff_5)

-- Boost movement (Up and Down) --

local function boostforwardbackward(player)
	if (player.midjump == true) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.forwardmove > 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 13*FRACUNIT)
	elseif (player.cmd.forwardmove < 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -13*FRACUNIT)
	end
	if (player.cmd.forwardmove > 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 5*FRACUNIT)
	elseif (player.cmd.forwardmove < 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -5*FRACUNIT)
	end
	if (player.cmd.forwardmove > 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 22*FRACUNIT)
	elseif (player.cmd.forwardmove < 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -22*FRACUNIT)
	end
	if (player.cmd.forwardmove > 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 8*FRACUNIT)
	elseif (player.cmd.forwardmove < 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, -8*FRACUNIT)
	end
end

-- Boost movement (Left and Right) --

local function boostside(player)
	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 13*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -13*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 5*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -5*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 13*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -13*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 5*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -5*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 2*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -2*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 8*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -8*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 8*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -8*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove == 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 8*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove == 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -8*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove > 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 4*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove > 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -4*FRACUNIT)
	end
	if (player.cmd.sidemove > 0 and player.cmd.forwardmove < 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, 4*FRACUNIT)
	elseif (player.cmd.sidemove < 0 and player.cmd.forwardmove < 0 and player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle-ANGLE_90, -4*FRACUNIT)
	end
end

-- Boost movement (For analog's Controls) --

local function boostanalog(player)
	if (player.pflags&PF_SPINNING) then
		return
	end
	if not (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.midjump == false and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 13*FRACUNIT)
	elseif (player.midjump == true and not player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 5*FRACUNIT)
	end
	if (player.midjump == false and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 22*FRACUNIT)
	elseif (player.midjump == true and player.powers[pw_super]) then
		P_Thrust(player.mo, player.mo.angle, 8*FRACUNIT)
	end
end

-- Boost --

local function boostmode(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		player.canomegabum = false
		player.omegau = false
		return
	end
	if (player.usingfly == true) then
		player.canomegabum = false
		player.omegau = false
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canuseboost == false) then
		player.canomegabum = false
		return
	end
	if (player.usingboost == false) then
		player.canomegabum = false
		player.omegau = false
		return
	end
	if (player.ringenergy == 0 and player.usingboost == true and not player.powers[pw_super]) then
		player.mo.state = S_PLAY_RUN
		player.usingboost = false
		return
	end
	if (player.usingboost == true) then
		player.lastangleturn = player.cmd.angleturn
		boostforwardbackward(player)
		boostside(player)
		boostanalog(player)
		if not (player.cmd.buttons&BT_CUSTOM1) then
			player.canomegabum = true
		end
		if (player.cmd.buttons&BT_CUSTOM1 and player.canomegabum == true) then
			if not player.pressedc1peel
			if (player.powers[pw_super]) then
				if (player.rings >= 50) then
					P_InstaThrust(player.mo, player.mo.angle, 700*FRACUNIT)
					S_StartSound(player.mo, sfx_bostex)
					P_FlashPal(player, PAL_WHITE, 8)
					player.rings = $1 - 8
					player.flyex = true
					player.omegau = true
				end
			else
				if (player.ringenergy >= 80) then
					player.ringenergy = $1 - 32
					P_InstaThrust(player.mo, player.mo.angle, 400*FRACUNIT)
					S_StartSound(player.mo, sfx_bostex)
					player.omegau = true
				end
			end
		end
			player.pressedc1peel = true
		else
			player.pressedc1peel = false
		end
	end
end

addHook("PlayerThink", boostmode)

-- SUPER PEEL-OUT --

-- Fase 2 Timer --

local function peelouttimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic")
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.peelfase1 == false) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.peeltimer == nil) then
		player.peeltimer = 0
		end

	player.peeltimer = $1 + 1

	if (player.peeltimer > 1*TICRATE) then
		player.peelfase2 = true
		player.peelfase1 = false
		player.peeltimer = nil
		player.mo.state = S_PLAY_PEEL1
	end
end

addHook("PlayerThink", peelouttimer)

-- Fase 3 Timer --

local function peelouttimer2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic")
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.peelfase2 == false) then
		return
	end
	if (player.peelfase3 == true) then
		return
	end
	if (player.peeltimer2 == nil) then
		player.peeltimer2 = 0
		end

	player.peeltimer2 = $1 + 1

	if (player.peeltimer2 > 1*TICRATE) then
		player.peelfase3 = true
		player.peelfase2 = false
		player.peeltimer2 = nil
		player.mo.state = S_PLAY_SPEEL1
	end
end

addHook("PlayerThink", peelouttimer2)

-- States --

-- 1 --

local function peeloutstate1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == false) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.peelfase3 == true) then
		return
	end
	player.mo.momx = 0
	player.mo.momy = 0
	local dst1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	P_SetObjectMomZ(dst1, P_RandomRange(2, 1)*FRACUNIT, false)
	P_InstaThrust(dst1, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -18)*FRACUNIT)
	dst1.scale = player.mo.scale*2/3
	if (player.powers[pw_shield] == SH_ELEMENTAL) then
		dst1.state = S_SPINDUST_FIRE1
	end
	if (player.mo.eflags&MFE_TOUCHWATER or player.mo.eflags&MFE_UNDERWATER) then
		dst1.state = S_SPINDUST_BUBBLE1
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		dst1.eflags = MFE_VERTICALFLIP
	end
	if (player.mo.state ~= S_PLAY_PWALK1 and player.mo.state ~= S_PLAY_PWALK2) then
		player.mo.state = S_PLAY_PWALK1
	end
	player.peelfase1 = true
	player.peelfase2 = false
	player.peelfase3 = false
	player.usingpeel = true
	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.mo.flags2&MF2_TWOD) then
		return
	end
	if (twodlevel) then
		return
	end
	player.drawangle = camera.angle
end

addHook("PlayerThink", peeloutstate1)

-- 2 --

local function peeloutstate2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == true) then
		return
	end
	if (player.peelfase2 == false) then
		return
	end
	if (player.peelfase3 == true) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	player.mo.momx = 0
	player.mo.momy = 0
	local dst1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	P_SetObjectMomZ(dst1, P_RandomRange(4, 1)*FRACUNIT, false)
	P_InstaThrust(dst1, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -18)*FRACUNIT)
	dst1.scale = player.mo.scale*2/3
	if (player.powers[pw_shield] == SH_ELEMENTAL) then
		dst1.state = S_SPINDUST_FIRE1
	end
	if (player.mo.eflags&MFE_TOUCHWATER or player.mo.eflags&MFE_UNDERWATER) then
		dst1.state = S_SPINDUST_BUBBLE1
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		dst1.eflags = MFE_VERTICALFLIP
	end
	local dst2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	P_SetObjectMomZ(dst2, P_RandomRange(4, 1)*FRACUNIT, false)
	P_InstaThrust(dst2, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -18)*FRACUNIT)
	dst2.scale = player.mo.scale*2/3
	if (player.powers[pw_shield] == SH_ELEMENTAL) then
		dst2.state = S_SPINDUST_FIRE1
	end
	if (player.mo.eflags&MFE_TOUCHWATER or player.mo.eflags&MFE_UNDERWATER) then
		dst2.state = S_SPINDUST_BUBBLE1
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		dst2.eflags = MFE_VERTICALFLIP
	end
	player.peelfase3 = false
	player.peelfase2 = true
	player.usingpeel = true
	if (player.mo.state ~= S_PLAY_PEEL1 and player.mo.state ~= S_PLAY_PEEL2) then
		player.mo.state = S_PLAY_PEEL1
	end
	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.mo.flags2&MF2_TWOD) then
		return
	end
	if (twodlevel) then
		return
	end
	player.drawangle = camera.angle
end

addHook("PlayerThink", peeloutstate2)

-- 3 --

-- TIMER color --

local function fase3timeron(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == true) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.peelfase3 == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.fse3colortimer == nil) then
		player.fse3colortimer = 0
		end
	
	player.fse3colortimer = $1 + 1

	if (player.fse3colortimer == 1*TICRATE/10 and player.mo.colorized == false) then
		player.mo.colorized = true
		player.fse3colortimer = nil
		return
	end
	if (player.fse3colortimer == 1*TICRATE/10 and player.mo.colorized == true) then
		player.mo.colorized = false
		player.fse3colortimer = nil
		return
	end
end

addHook("PlayerThink", fase3timeron)

local function peeloutstate3(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == true) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.peelfase3 == false) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end	
	player.mo.momx = 0
	player.mo.momy = 0
	local dst1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	P_SetObjectMomZ(dst1, P_RandomRange(4, 1)*FRACUNIT, false)
	P_InstaThrust(dst1, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -18)*FRACUNIT)
	if (player.powers[pw_shield] == SH_ELEMENTAL) then
		dst1.state = S_SPINDUST_FIRE1
	end
	if (player.mo.eflags&MFE_TOUCHWATER or player.mo.eflags&MFE_UNDERWATER) then
		dst1.state = S_SPINDUST_BUBBLE1
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		dst1.eflags = MFE_VERTICALFLIP
	end
	local dst2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	P_SetObjectMomZ(dst2, P_RandomRange(4, 1)*FRACUNIT, false)
	dst2.scale = player.mo.scale*2/3
	P_InstaThrust(dst2, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -18)*FRACUNIT)
	if (player.powers[pw_shield] == SH_ELEMENTAL) then
		dst2.state = S_SPINDUST_FIRE1
	end
	if (player.mo.eflags&MFE_TOUCHWATER or player.mo.eflags&MFE_UNDERWATER) then
		dst2.state = S_SPINDUST_BUBBLE1
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		dst2.eflags = MFE_VERTICALFLIP
	end
	player.peelfase2 = false
	player.peelfase1 = false
	player.peelfase3 = true
	player.usingpeel = true
	if (player.mo.state ~= S_PLAY_SPEEL1 and player.mo.state ~= S_PLAY_SPEEL2) then
		player.mo.state = S_PLAY_SPEEL1
	end
	if (player.pflags&PF_ANALOGMODE) then
		return
	end
	if (player.mo.flags2&MF2_TWOD) then
		return
	end
	if (twodlevel) then
		return
	end
	player.drawangle = camera.angle
end

addHook("PlayerThink", peeloutstate3)

-- Release peel-out --

-- 1 --

local function peeloutvar1(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == false) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.peelfase3 == true) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM1) then
		return
	end
	player.peelfase1 = false
	player.peelfase2 = false
	player.peelfase3 = false
	player.peeltimer = nil
	player.peeltimer2 = nil
	player.mo.colorized = false
	player.fse3colortimer = nil
	player.mo.state = S_PLAY_STND
	player.usingpeel = false
end

addHook("PlayerThink", peeloutvar1)

-- 2 --

local function peeloutvar2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.peelfase2 == false) then
		return
	end
	if (player.peelfase3 == true) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM1) then
		return
	end
	player.peeltimer = nil
	player.peeltimer2 = nil
	player.peelfase1 = false
	player.peelfase2 = false
	player.peelfase3 = false
	player.mo.colorized = false
	player.fse3colortimer = nil
	player.ringenergy = $1 - 8
	player.mo.state = S_PLAY_RUN
	S_StartSound(player.mo, sfx_peelr)
	P_InstaThrust(player.mo, player.mo.angle, FixedMul(80*FRACUNIT, player.mo.scale))
	player.drawangle = player.mo.angle
	player.usingpeel = false
end

addHook("PlayerThink", peeloutvar2)

-- 3 --

local function peeloutvar3(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.peelfase1 == true) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.peelfase3 == false) then
		return
	end
	if (player.usingpeel == false) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM1) then
		return
	end
	if (player.ringenergy < 20 and not player.powers[pw_super]) then
		player.peelfase1 = false
		player.peelfase2 = false
		player.peelfase3 = false
		player.ringenergy = $1 - 8
		player.mo.state = S_PLAY_RUN
		S_StartSound(player.mo, sfx_peelr)
		P_InstaThrust(player.mo, player.mo.angle, FixedMul(80*FRACUNIT, player.mo.scale))
		player.drawangle = player.mo.angle
		player.peeltimer = nil
		player.peeltimer2 = nil
		player.mo.colorized = false
		player.fse3colortimer = nil
		player.usingpeel = false
		return
	end
	player.peelfase1 = false
	player.peelfase2 = false
	player.peelfase3 = false
	player.ringenergy = $1 - 20
	player.mo.colorized = false
	player.fse3colortimer = nil
	player.peeltimer = nil
	player.peeltimer2 = nil
	S_StartSound(player.mo, sfx_peelr)
	P_InstaThrust(player.mo, player.mo.angle, FixedMul(160*FRACUNIT, player.mo.scale))
	player.drawangle = player.mo.angle
	S_StartSound(player.mo, sfx_bostex)
	player.mo.state = S_PLAY_DASH
	local ghs = P_SpawnGhostMobj(player.mo)
	ghs.fuse = 20
	ghs.scale = 2*FRACUNIT
	ghs.color = player.mo.color
	ghs.colorized = true
	local BSEX = P_SpawnMobjFromMobj (player.mo, 0*FRACUNIT, 0*FRACUNIT, 0*FRACUNIT, MT_BOOSTEXPLOSION)
	BSEX.angle = player.mo.angle
	BSEX.scale = 2*FRACUNIT/2
	player.BSTP = P_SpawnMobjFromMobj (player.mo, 0*FRACUNIT, 0*FRACUNIT, 0*FRACUNIT, MT_BOOSTEXP2)
	P_Thrust(player.BSTP, player.mo.angle, -8*FRACUNIT)
	local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk1.color = player.mo.color
	local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk2.color = player.mo.color
	local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk3.color = player.mo.color
	local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk4.color = player.mo.color
	local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk5.color = player.mo.color
	local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk6.color = player.mo.color
	local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk7.color = player.mo.color
	local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
	sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
	sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
	sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
	sprk8.color = player.mo.color
	player.lastangleturn = player.cmd.angleturn
	player.usingboost = true
	boostforwardbackward(player)
	boostside(player)
	boostanalog(player)
	player.usingpeel = false
end

addHook("PlayerThink", peeloutvar3)

-- Peel-out activation sound --

local function peelsound(player)
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	S_StartSound(player.mo, sfx_peelc)
end

-- The Peel-Out --

local function peelout(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canusepeel == false) then
		return
	end
	if (player.playerstate == PST_DEAD) then
		return
	end
	if (player.peelfase1 == true) then
		return
	end
	if (player.peelfase2 == true) then
		return
	end
	if (player.usingpeel == true) then
		return
	end
	if (player.peelfase3 == true) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.ringenergy == 0 and not player.powers[pw_super]) then
		return
	end
	if (player.speed > 4*FRACUNIT) then
		return
	end
	if (player.cmd.forwardmove ~= 0) or (player.cmd.sidemove ~= 0) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM1) then
		if not player.pressedc1peel
		player.mo.state = S_PLAY_PWALK1
		player.usingpeel = true
		player.peelfase1 = true
		player.peelfase2 = false
		player.peelfase3 = false
		peelsound(player)
	end
		player.pressedc1peel = true
	else
		player.pressedc1peel = false
	end
end

addHook("PlayerThink", peelout)

-- BOUNCE JUMP --

-- without Super --

local function Bounce1(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
	if (player.mo.eflags&~MFE_VERTICALFLIP) then
		local bjeffect = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BOUNCEJUMPEW)
		bjeffect.color = player.mo.color
		bjeffect.renderflags = RF_FLOORSPRITE
		player.pflags = $1|PF_JUMPED
		player.mo.state = S_PLAY_JUMP
		local BOUNCEG = P_SpawnGhostMobj(player.mo)
		BOUNCEG.colorized = true
		P_SetObjectMomZ(player.mo, 10*FRACUNIT+player.bouncenum*FRACUNIT*2, false)
		S_StartSound(player.mo, sfx_bjup)
		player.blockdthok = true
		player.canusedropdash = false
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
		player.bjauraeffect = true
		player.charability2 = CA2_SPINDASH
	end
end

local function Bounce2(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		local bjeffect = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BOUNCEJUMPEW)
		bjeffect.color = player.mo.color
		bjeffect.renderflags = RF_FLOORSPRITE
		player.pflags = $1|PF_JUMPED
		player.mo.state = S_PLAY_JUMP
		local BOUNCEG = P_SpawnGhostMobj(player.mo)
		BOUNCEG.colorized = true
		P_SetObjectMomZ(player.mo, 5*FRACUNIT+player.bouncenum*FRACUNIT*2, false)
		S_StartSound(player.mo, sfx_bjup)
		player.blockdthok = true
		player.canusedropdash = false
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
		player.bjauraeffect = true
		player.charability2 = CA2_SPINDASH
	end
end

local function bouncejumpup(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true and player.usedrecull == false) then
		return
	end
	if (player.usingbouncejump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim == PA_IDLE) or (player.panim == PA_WALK) or (player.panim == PA_RUN) or 
	(player.panim == PA_ROLL) or (player.panim == PA_DASH) or (player.panim == PA_EDGE) then
		player.canusepeel = false
		if (player.bouncenum ~= 3) then
			player.bouncenum = $1 + 1
		end
		Bounce1(player)
		Bounce2(player)
		player.bjauraeffect = true
		if not (player.powers[pw_shield] == SH_ELEMENTAL) then
			local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust1, player.mo.angle, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust1.state = S_SPINDUST_BUBBLE1
				dust1.scale = player.mo.scale*2
			end
			local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust2, player.mo.angle-ANGLE_45, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust2.state = S_SPINDUST_BUBBLE1
				dust2.scale = player.mo.scale*2
			end
			local dust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust3, player.mo.angle-ANGLE_90, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust3.state = S_SPINDUST_BUBBLE1
				dust3.scale = player.mo.scale*2
			end
			local dust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust4, player.mo.angle-ANGLE_135, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust4.state = S_SPINDUST_BUBBLE1
				dust4.scale = player.mo.scale*2
			end
			local dust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust5, player.mo.angle-ANGLE_180, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust5.state = S_SPINDUST_BUBBLE1
				dust5.scale = player.mo.scale*2
			end
			local dust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust6, player.mo.angle-ANGLE_225, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust6.state = S_SPINDUST_BUBBLE1
				dust6.scale = player.mo.scale*2
			end
			local dust7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust7, player.mo.angle-ANGLE_270, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust7.state = S_SPINDUST_BUBBLE1
				dust7.scale = player.mo.scale*2
			end
			local dust8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust8, player.mo.angle-ANGLE_315, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust8.state = S_SPINDUST_BUBBLE1
				dust8.scale = player.mo.scale*2
			end
			if (player.mo.eflags&MFE_VERTICALFLIP) then
				dust1.eflags = MFE_VERTICALFLIP
				dust2.eflags = MFE_VERTICALFLIP
				dust3.eflags = MFE_VERTICALFLIP
				dust4.eflags = MFE_VERTICALFLIP
				dust5.eflags = MFE_VERTICALFLIP
				dust6.eflags = MFE_VERTICALFLIP
				dust7.eflags = MFE_VERTICALFLIP
				dust8.eflags = MFE_VERTICALFLIP
			end
		else		
			if (player.mo.eflags&~MFE_UNDERWATER) then
				local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust1, player.mo.angle, 4*FRACUNIT)
				local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust2, player.mo.angle-ANGLE_45, 4*FRACUNIT)
				local dust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust3, player.mo.angle-ANGLE_90, 4*FRACUNIT)
				local dust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust4, player.mo.angle-ANGLE_135, 4*FRACUNIT)
				local dust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust5, player.mo.angle-ANGLE_180, 4*FRACUNIT)
				local dust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust6, player.mo.angle-ANGLE_225, 4*FRACUNIT)
				local dust7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust7, player.mo.angle-ANGLE_270, 4*FRACUNIT)
				local dust8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
				P_InstaThrust(dust8, player.mo.angle-ANGLE_315, 4*FRACUNIT)
				if (player.mo.eflags&MFE_VERTICALFLIP) then
					dust1.eflags = MFE_VERTICALFLIP
					dust2.eflags = MFE_VERTICALFLIP
					dust3.eflags = MFE_VERTICALFLIP
					dust4.eflags = MFE_VERTICALFLIP
					dust5.eflags = MFE_VERTICALFLIP
					dust6.eflags = MFE_VERTICALFLIP
					dust7.eflags = MFE_VERTICALFLIP
					dust8.eflags = MFE_VERTICALFLIP
				end
			end
			if (player.mo.eflags&MFE_UNDERWATER) then
				local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust1, player.mo.angle, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust1.state = S_SPINDUST_BUBBLE1
					dust1.scale = player.mo.scale*2
				end
				local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust2, player.mo.angle-ANGLE_45, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust2.state = S_SPINDUST_BUBBLE1
					dust2.scale = player.mo.scale*2
				end
				local dust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust3, player.mo.angle-ANGLE_90, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust3.state = S_SPINDUST_BUBBLE1
					dust3.scale = player.mo.scale*2
				end
				local dust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust4, player.mo.angle-ANGLE_135, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust4.state = S_SPINDUST_BUBBLE1
					dust4.scale = player.mo.scale*2
				end
				local dust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust5, player.mo.angle-ANGLE_180, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust5.state = S_SPINDUST_BUBBLE1
					dust5.scale = player.mo.scale*2
				end
				local dust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust6, player.mo.angle-ANGLE_225, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust6.state = S_SPINDUST_BUBBLE1
					dust6.scale = player.mo.scale*2
				end
				local dust7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust7, player.mo.angle-ANGLE_270, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust7.state = S_SPINDUST_BUBBLE1
					dust7.scale = player.mo.scale*2
				end
				local dust8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
				P_InstaThrust(dust8, player.mo.angle-ANGLE_315, 16*FRACUNIT)
				if (player.mo.eflags&MFE_UNDERWATER) then
					dust8.state = S_SPINDUST_BUBBLE1
					dust8.scale = player.mo.scale*2
				end
				if (player.mo.eflags&MFE_VERTICALFLIP) then
					dust1.eflags = MFE_VERTICALFLIP
					dust2.eflags = MFE_VERTICALFLIP
					dust3.eflags = MFE_VERTICALFLIP
					dust4.eflags = MFE_VERTICALFLIP
					dust5.eflags = MFE_VERTICALFLIP
					dust6.eflags = MFE_VERTICALFLIP
					dust7.eflags = MFE_VERTICALFLIP
					dust8.eflags = MFE_VERTICALFLIP
				end
			end
		end
		local currentsector = R_PointInSubsector(player.mo.x, player.mo.y).sector for fof in currentsector.ffloors()
			if (fof.flags&FF_EXISTS and fof.flags&FF_BUSTUP) or
			(fof.flags&FF_EXISTS and fof.flags&FF_BUSTUP and fof.flags&FF_STRONGBUST) then
				EV_CrumbleChain(currentsector, fof)
				S_StartSound(player.mo,sfx_crnc)
			end
		end
	end
end

addHook("PlayerThink", bouncejumpup)

-- With Super --

local function sbounce1(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
		local bjeffect = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BOUNCEJUMPEW)
		bjeffect.color = player.mo.color
		bjeffect.renderflags = RF_FLOORSPRITE
		player.pflags = $1|PF_JUMPED
		player.mo.state = S_PLAY_JUMP
		local BOUNCEGS = P_SpawnGhostMobj(player.mo)
		BOUNCEGS.colorized = true
		P_SetObjectMomZ(player.mo, 15*FRACUNIT+player.bouncenum*FRACUNIT*2, false)
		S_StartSound(player.mo, sfx_bjup)
		player.blockdthok = true
		player.canusedropdash = false
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
		player.bjauraeffect = true
		player.charability2 = CA2_SPINDASH
	end

local function sbounce2(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		local bjeffect = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BOUNCEJUMPEW)
		bjeffect.color = player.mo.color
		bjeffect.renderflags = RF_FLOORSPRITE
		player.pflags = $1|PF_JUMPED
		player.mo.state = S_PLAY_JUMP
		S_StartSound(player.mo, sfx_bjup)
		local BOUNCEGS = P_SpawnGhostMobj(player.mo)
		BOUNCEGS.colorized = true
		P_SetObjectMomZ(player.mo, 9*FRACUNIT+player.bouncenum*FRACUNIT*2, false)
		player.blockdthok = true
		player.canusedropdash = false
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
		player.bjauraeffect = true
		player.charability2 = CA2_SPINDASH
	end
end

local function superbouncejumpup(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingbouncejump == false) then
		return
	end
	if (player.blockallabilities == true and player.usedrecull == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.panim == PA_IDLE) or (player.panim == PA_WALK) or (player.panim == PA_RUN) or 
	(player.panim == PA_ROLL) or (player.panim == PA_DASH) or (player.panim == PA_EDGE) then
		player.canusepeel = false
		if (player.bouncenum ~= 3) then
			player.bouncenum = $1 + 1
		end
		sbounce1(player)
		sbounce2(player)
		player.bjauraeffect = true
		if not (player.mo.eflags&MFE_UNDERWATER) then
			local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust1, player.mo.angle, 4*FRACUNIT)
			local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust2, player.mo.angle-ANGLE_45, 4*FRACUNIT)
			local dust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust3, player.mo.angle-ANGLE_90, 4*FRACUNIT)
			local dust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust4, player.mo.angle-ANGLE_135, 4*FRACUNIT)
			local dust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust5, player.mo.angle-ANGLE_180, 4*FRACUNIT)
			local dust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust6, player.mo.angle-ANGLE_225, 4*FRACUNIT)
			local dust7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust7, player.mo.angle-ANGLE_270, 4*FRACUNIT)
			local dust8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 4*FRACUNIT, MT_SPINFIRE)
			P_InstaThrust(dust8, player.mo.angle-ANGLE_315, 4*FRACUNIT)
			if (player.mo.eflags&MFE_VERTICALFLIP) then
				dust1.eflags = MFE_VERTICALFLIP
				dust2.eflags = MFE_VERTICALFLIP
				dust3.eflags = MFE_VERTICALFLIP
				dust4.eflags = MFE_VERTICALFLIP
				dust5.eflags = MFE_VERTICALFLIP
				dust6.eflags = MFE_VERTICALFLIP
				dust7.eflags = MFE_VERTICALFLIP
				dust8.eflags = MFE_VERTICALFLIP
			end
		end
		if (player.mo.eflags&MFE_UNDERWATER) then
			local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust1, player.mo.angle, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust1.state = S_SPINDUST_BUBBLE1
				dust1.scale = player.mo.scale*2
			end
			local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust2, player.mo.angle-ANGLE_45, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust2.state = S_SPINDUST_BUBBLE1
				dust2.scale = player.mo.scale*2
			end
			local dust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust3, player.mo.angle-ANGLE_90, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust3.state = S_SPINDUST_BUBBLE1
				dust3.scale = player.mo.scale*2
			end
			local dust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust4, player.mo.angle-ANGLE_135, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust4.state = S_SPINDUST_BUBBLE1
				dust4.scale = player.mo.scale*2
			end
			local dust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust5, player.mo.angle-ANGLE_180, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust5.state = S_SPINDUST_BUBBLE1
				dust5.scale = player.mo.scale*2
			end
			local dust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust6, player.mo.angle-ANGLE_225, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust6.state = S_SPINDUST_BUBBLE1
				dust6.scale = player.mo.scale*2
			end
			local dust7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust7, player.mo.angle-ANGLE_270, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust7.state = S_SPINDUST_BUBBLE1
				dust7.scale = player.mo.scale*2
			end
			local dust8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 1*FRACUNIT, MT_SPINDUST)
			P_InstaThrust(dust8, player.mo.angle-ANGLE_315, 16*FRACUNIT)
			if (player.mo.eflags&MFE_UNDERWATER) then
				dust8.state = S_SPINDUST_BUBBLE1
				dust8.scale = player.mo.scale*2
			end
			if (player.mo.eflags&MFE_VERTICALFLIP) then
				dust1.eflags = MFE_VERTICALFLIP
				dust2.eflags = MFE_VERTICALFLIP
				dust3.eflags = MFE_VERTICALFLIP
				dust4.eflags = MFE_VERTICALFLIP
				dust5.eflags = MFE_VERTICALFLIP
				dust6.eflags = MFE_VERTICALFLIP
				dust7.eflags = MFE_VERTICALFLIP
				dust8.eflags = MFE_VERTICALFLIP
			end
		end
		local currentsector = R_PointInSubsector(player.mo.x, player.mo.y).sector for fof in currentsector.ffloors()
			if (fof.flags&FF_EXISTS and fof.flags&FF_BUSTUP) or
			(fof.flags&FF_EXISTS and fof.flags&FF_BUSTUP and fof.flags&FF_STRONGBUST) then
				EV_CrumbleChain(currentsector, fof)
				S_StartSound(player.mo,sfx_crnc)
			end
		end
	end
end

addHook("PlayerThink", superbouncejumpup)

-- To force the desactivation of Bounce Jump --

local function forcebounceoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim == PA_SPRING) then
		return
	end
	if (player.usingbouncejump == false) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		player.usingbouncejump = false
		player.bjauraeffect = false
	end
end

addHook("PlayerThink", forcebounceoff)

local function forcebounceoff2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.panim == PA_SPRING) then
		return
	end
	if (player.mo.momz > 0 and player.usingbouncejump == true) then
		player.blockdthok = true
		player.canusedropdash = true
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
	end
end

addHook("PlayerThink", forcebounceoff2)

local function forcebounceoff3(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags&~MFE_VERTICALFLIP) then
		return
	end
	if (player.panim == PA_SPRING) then
		return
	end
	if (player.mo.momz < 0 and player.usingbouncejump == true) then
		player.blockdthok = true
		player.canusedropdash = true
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
	end
end

addHook("PlayerThink", forcebounceoff3)

local function bounceeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		player.bjauraeffect = false
		return
	end		
	if (player.bjauraeffect == true) then
		local effect = SmoothTrail(player.mo, MT_BTHOK, 8*FRACUNIT, player.mo.color)
	end
end

addHook("PlayerThink", bounceeffect)

local function bjat(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.bjauraeffect == false) then
		return
	end
	if (player.mo.momz <= 2*FRACUNIT and player.mo.momz >= -2*FRACUNIT) then
		player.bjauraeffect = false
	end
end

addHook("PlayerThink", bjat)

local function springbouncepart2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if not (player.springtarget and player.springtarget.valid) then
		return
	end
	if (player.midjump == false) then
		player.springtarget = nil
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.panim ~= PA_ROLL and player.bounceinspring == true and player.mo.momz > 0*FRACUNIT) then
		player.mo.momz = $1 + 8*FRACUNIT
		player.blockdthok = true
		player.canusedropdash = true
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
		player.bounceinspring = false
		player.springtarget = nil
	end
end

addHook("PlayerThink", springbouncepart2)

local function springbouncepart2_5(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if not (player.springtarget and player.springtarget.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		player.springtarget = nil
		return
	end
	if not (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.panim ~= PA_ROLL and player.bounceinspring == true and player.mo.momz < 0*FRACUNIT) then
		player.mo.momz = $1 - 8*FRACUNIT
		player.blockdthok = true
		player.canusedropdash = true
		player.canusest = true
		player.usedsecondarythok = false
		player.usedbj = true
		player.usingbouncejump = false
		player.bounceinspring = false
		player.springtarget = nil
	end
end

addHook("PlayerThink", springbouncepart2_5)

local function springbounce(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		player.springtarget = mo
		return
	end
	if (player.usingbouncejump == false) then
		return
	end

	player.springtarget = nil
	for mo in mobjs.iterate()
	
		if not (mo and mo.valid) then
			continue
		end
		if not (mo.flags&MF_SPRING) then
			continue
		end
		local springdist = FixedMul(48*FRACUNIT, player.mo.scale)
		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y), player.mo.z-mo.z) > springdist) then
			continue
		end
		if (player.springtarget and 
		P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y), player.mo.z-mo.z) > 
		P_AproxDistance(P_AproxDistance(player.mo.x-player.springtarget.x, player.mo.y-player.springtarget.y), player.mo.z-player.springtarget.z)) then
			continue
		end
		player.bounceinspring = true
		player.springtarget = mo
		springbouncepart2(player)
		springbouncepart2_5(player)
	end
end

addHook("PlayerThink", springbounce)

local function bjresetspring(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.usingbouncejump == false) then
		player.springtarget = nil
	end
end

addHook("PlayerThink", bjresetspring)

-- Start Bounce Jump, to With and Without Super --

local function bouncejumpdown(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockallabilities == true and player.usedrecull == false) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.canusebouncejump == false) then
		return
	end
	if (player.spincount == false) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		if not player.pressedsc2
		player.usingbouncejump = true
		player.canusepeel = false
		player.allowmj = false
		player.mo.state = S_PLAY_JUMP
		P_SpawnGhostMobj(player.mo)
		P_SetObjectMomZ(player.mo, -24*FRACUNIT, false)
		player.blockdthok = true
		player.usedsecondarythok = false
		player.usedbj = false
		player.bjtimer = nil
		player.canusest = false
		player.canusedropdash = false
		player.bjauraeffect = true
		player.charability2 = CA2_NONE
		bouncejumpup(player)
		superbouncejumpup(player)
		if (player.speed < 5*FRACUNIT and player.cmd.forwardmove > 0) then
			P_InstaThrust(player.mo, player.mo.angle, 5*FRACUNIT)
		end
	end
		player.pressedsc2 = true
	else
		player.pressedsc2 = false
	end
end

addHook("PlayerThink", bouncejumpdown)

local function timerbouncejump(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedbj == false) then
		return
	end
	if (player.panim ~= PA_ROLL) then
		return
	end
	if (player.bjtimer == nil) then
		player.bjtimer = 0
		end

		player. bjtimer = $1 + 1
	
	if (player.bjtimer == 4*TICRATE/5) then
		player.mo.state = S_PLAY_JUMP
		player.canusepeel = true
		player.canusedropdash = true
		player.bjauraeffect = false
		player.usedbj = false
		player.bjtimer = nil
		end
	end

addHook("PlayerThink", timerbouncejump)

-- DROP DASH --

-- Sound --

local function dropdashsound(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if  (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.dropdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canusedropdash == false) then
		return
	end
	if (player.dropsound == true) then
		return
	end
	S_StartSound(player.mo, sfx_drda)
	local ddg1 = P_SpawnGhostMobj(player.mo)
	ddg1.colorized = true
	player.dropsound = true
end

addHook("PlayerThink", dropdashsound)

-- Drop Dash Dust or Bubbles --

local function dropdust(player)
	local dropdust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_DUST)
	P_InstaThrust(dropdust1, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-6, -2)*FRACUNIT)
	local dropdust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_DUST)
	P_InstaThrust(dropdust2, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-6, -2)*FRACUNIT)
	local dropdust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_DUST)
	P_InstaThrust(dropdust3, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-6, -2)*FRACUNIT)
	local dropdust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_DUST)
	P_InstaThrust(dropdust4, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-6, -2)*FRACUNIT)
	local dropdust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_DUST)
	P_InstaThrust(dropdust5, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-6, -2)*FRACUNIT)
	local dropdust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_DUST)
	P_InstaThrust(dropdust6, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-6, -2)*FRACUNIT)
		return
	end

local function dropdustw(player)
	local dropbub1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_MEDIUMBUBBLE)
	P_InstaThrust(dropbub1, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -1)*FRACUNIT)
	local dropbub2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_MEDIUMBUBBLE)
	P_InstaThrust(dropbub2, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -1)*FRACUNIT)
	local dropbub3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_MEDIUMBUBBLE)
	P_InstaThrust(dropbub3, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -1)*FRACUNIT)
	local dropbub4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_MEDIUMBUBBLE)
	P_InstaThrust(dropbub4, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -1)*FRACUNIT)
	local dropbub5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_MEDIUMBUBBLE)
	P_InstaThrust(dropbub5, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -1)*FRACUNIT)
	local dropbub6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 2*FRACUNIT, MT_MEDIUMBUBBLE)
	P_InstaThrust(dropbub6, player.mo.angle+P_RandomRange(45, -45)*ANG1, P_RandomRange(-4, -1)*FRACUNIT)
		return
	end

local function dropsoundeffect(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags & MFE_UNDERWATER) then
		dropdustw(player)
		S_StartSound(player.mo, sfx_s3k7d)
	else
		dropdust(player)
		S_StartSound(player.mo, sfx_s23c)
	end
end


local function usedropdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusedropdash == false) then
		return
	end
	if (player.dropdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_IsObjectOnGround(player.mo) then
		player.mo.state = S_PLAY_ROLL
		player.pflags = $1|PF_SPINNING
		P_SetObjectMomZ(player.mo, -4*FRACUNIT, false)
		dropsoundeffect(player)
		P_InstaThrust(player.mo, player.mo.angle, 46*FRACUNIT)
		player.dropdash = false
	end
end

addHook("PlayerThink", usedropdash)

-- To activate the Drop Dash --

local function activatedropdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.canusedropdash == false) then
		return
	end
	if (player.cmd.buttons & BT_SPIN) then
		if (player.droptimer == nil) then
			player.droptimer = 0
		end
		
		player.droptimer = $1 + 1

	if (player.droptimer == 1*TICRATE/5) then
		player.droptimer = nil
		player.dropdash = true
		player.candropw = true
		end
	end
end

addHook ("PlayerThink", activatedropdash)

-- To desactivate the Drop Dash --

local function desactivatedropdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.cmd.buttons&BT_SPIN) then
		player.dropdash = false
		player.dropsound = false
		player.droptimer = nil
	end
end

addHook ("PlayerThink", desactivatedropdash)

-- force desactivation --

local function forcedropdashoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		player.dropdash = false
		player.dropsound = false
	end
end

addHook("PlayerThink", forcedropdashoff)

local function forcedropdashoff2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.useddropthok == true) then
		player.dropsound = true
	end
end

addHook("PlayerThink", forcedropdashoff2)

local function forcedropdashoff3(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.canusedropdash == false) then
		player.dropdash = false
		player.dropsound = false
		if (player.powers[pw_super]) then
			player.superdropdash = false
			player.superdropsound = false
		end
	end
end

addHook("PlayerThink", forcedropdashoff3)

local function forcedropdashoff4(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingbouncejump == true) then
		player.dropdash = false
		player.dropsound = false
		if (player.powers[pw_super]) then
			player.superdropdash = false
			player.superdropsound = false
		end
	end
end

addHook("PlayerThink", forcedropdashoff4)

local function forcedropdashoff5(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockallabilities == true) then
		player.dropdash = false
		player.dropsound = false
		if (player.powers[pw_super]) then
			player.superdropdash = false
			player.superdropsound = false
		end
	end
end

addHook("PlayerThink", forcedropdashoff5)

-- SUPER DROP DASH --

-- Sound --

local function superdropdashsound(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if  (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.superdropdash == false) then
		return
	end
	if (player.canusedropdash == false) then
		return
	end
	if (player.superdropsound == true) then
		return
	end
	local ddg2 = P_SpawnGhostMobj(player.mo)
	ddg2.colorized = true
	S_StartSound(player.mo, sfx_drda)
	player.superdropsound = true
end

addHook("PlayerThink", superdropdashsound)

-- When Sonic is on ground with the Super Drop Dash activated, do the dash --

local function usesuperdropdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusedropdash == false) then
		return
	end
	if (player.superdropdash == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if P_IsObjectOnGround(player.mo) then
		player.mo.state = S_PLAY_ROLL
		player.pflags = $1|PF_SPINNING
		P_SetObjectMomZ(player.mo, -4*FRACUNIT, false)
		dropsoundeffect(player)
		P_InstaThrust(player.mo, player.mo.angle, 68*FRACUNIT)
		player.superdropdash = false
	end
end

addHook("PlayerThink", usesuperdropdash)

-- To activate the Super Drop Dash --

local function activatesuperdropdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.canusedropdash == false) then
		return
	end
	if (player.cmd.buttons & BT_SPIN) then
		if (player.sdroptimer == nil) then
			player.sdroptimer = 0
		end
		
		player.sdroptimer = $1 + 1

	if (player.sdroptimer == 1*TICRATE/5) then
		player.superdropdash = true
		player.sdroptimer = nil
		player.candropw = true
		end
	end
end

addHook ("PlayerThink", activatesuperdropdash)

-- To desactivate the Super Drop Dash --

local function desactivatesuperdropdash(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons & BT_SPIN) then
		return
	end
		player.sdroptimer = nil
		player.superdropdash = false
		player.superdropsound = false
	end

addHook ("PlayerThink", desactivatesuperdropdash)

-- Force desactivation --

local function forcesuperdropdashoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usedsuperdropthok == true) then
		player.superdropsound = true
	end
end

addHook("PlayerThink", forcesuperdropdashoff)

-- DROP THOK --

-- Timer, unused --

local function dropthokontimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.canusedthok == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.dttimer == nil) then
		player.dttimer = 0
		end

		player.dttimer = $1 + 1

	if (player.dttimer > 0) then
		player.canusedthok = true
		player.dttimer = nil
		end
	end

addHook("PlayerThink", dropthokontimer)

-- Ghost --

local function dropthokghost(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusest == true) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.momz > 0 and player.mo.eflags&~MFE_VERTICALFLIP) then
		return
	end
	if (player.mo.momz < 0 and player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.useddropthok == true) then
		player.drawangle = player.lasttkangle
		local ghs = P_SpawnGhostMobj(player.mo)
		ghs.fuse = 5
		ghs.color = player.mo.color
		ghs.blendmode = AST_ADD
		local sprk = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPALTSPARKLE)
		sprk.momx = P_RandomRange(4, -4)*FRACUNIT
		sprk.momy = P_RandomRange(4, -4)*FRACUNIT
		sprk.momz = P_RandomRange(4, -4)*FRACUNIT
		sprk.color = player.mo.color
		if (player.dtd == nil) then
			player.dtd = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_DTHOKDECTECTOR)
		end
		if not (player.dtd and player.dtd.valid) then
			return
		end
		player.dtd.z = player.mo.z
		if (player.dthokdestroysectortimer == nil) then
			player.dthokdestroysectortimer = 0
		end
		if not (player.dtd and player.dtd.valid) then
			return
		end
		if not (player.dthokdestroysectortimer == 1*TICRATE/4) then
			player.dthokdestroysectortimer = $1 + 1
		end
		if not (player.dtd and player.dtd.valid) then
			return
		end
		if (player.dthokdestroysectortimer < 1*TICRATE/4) then
			P_InstaThrust(player.dtd, player.mo.angle, 32*FRACUNIT+player.speed)
		end
		if not (player.dtd and player.dtd.valid) then
			return
		end
		if (player.dthokdestroysectortimer == 1*TICRATE/4) then
			P_InstaThrust(player.dtd, player.mo.angle, player.speed)
		end
		if not (player.dtd and player.dtd.valid) then
			return
		end
		local currentsector = R_PointInSubsector(player.dtd.x, player.dtd.y).sector for fof in currentsector.ffloors()
			if (fof.flags&FF_STRONGBUST) then
				return
			end
			if (fof.flags&FF_EXISTS and fof.flags&FF_BUSTUP) then
				if (fof.topheight > player.mo.z and fof.bottomheight < player.mo.z) then
					EV_CrumbleChain(currentsector, fof)
				end
			end
		end
	end
end

addHook("PlayerThink", dropthokghost)

-- desactivate Ghost --

local function dropthokghostoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_IsObjectOnGround(player.mo) or (player.panim ~= PA_JUMP) or (player.usedsecondarythok == true) then
		player.useddropthok = false
		player.dthokdestroysectortimer = nil
		if (player.dtd and player.dtd.valid) then
			P_KillMobj(player.dtd)
			player.dtd = nil
		end
	end
end

addHook("PlayerThink", dropthokghostoff)

-- The Drop Thok --

local function dropthok(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.usedrecull == true) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.blockdthokc3 == true) then
		return
	end
	if (player.blockdthok == true) then
		return
	end
	if (player.canusedthok == false) then
		return
	end
	if (player.useddropthok == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.spincount == true) then
		return
	end
	if (player.jumpdthokblock == true) then
		return
	end
	if (player.ringenergy < 8 and not player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		if not player.pressedsj
		player.mo.momz = 0*FRACUNIT
		player.ringenergy = $1 - 8
		P_InstaThrust(player.mo, player.mo.angle, 96*FRACUNIT)
		S_StartSound(player.mo, sfx_spdthk)
		player.canusehomingattack = false
		player.lasttkangle = player.mo.angle
		local tk = P_SpawnMobjFromMobj(player.mo, 0, 0, 8*FRACUNIT, MT_ATHOK)
		tk.color = player.mo.color
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
		player.useddropthok = true
	end
		player.pressedsj = true
	else
		player.pressedsj = false
	end
end

addHook("PlayerThink", dropthok)

-- The Drop Thok (water version) --

local function dropthokw(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.canusest == true) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if not (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.usedrecull == true) then
		return
	end
	if (player.blockdthokc3 == true) then
		return
	end
	if (player.blockdthok == true) then
		return
	end
	if (player.canusedthok == false) then
		return
	end
	if (player.useddropthok == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.spincount == true) then
		return
	end
	if (player.jumpdthokblock == true) then
		return
	end
	if (player.ringenergy < 8 and not player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		if not player.pressedsjw
		player.mo.momz = 0*FRACUNIT
		player.ringenergy = $1 - 8
		P_InstaThrust(player.mo, player.mo.angle, 64*FRACUNIT)
		S_StartSound(player.mo, sfx_splash)
		P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_UWEXPLODE)
		player.lasttkangle = player.mo.angle
		player.canusehomingattack = false
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
		player.useddropthok = true
	end
		player.pressedsjw = true
	else
		player.pressedsjw = false
	end
end

addHook("PlayerThink", dropthokw)

-- SUPER DROP THOK --

-- Ghost --

local function superdropthokghost(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusest == true) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.momz > 0 and player.mo.eflags&~MFE_VERTICALFLIP) then
		return
	end
	if (player.mo.momz < 0 and player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.usedsuperdropthok == true) then
		player.drawangle = player.lasttkangle
		local ghs = P_SpawnGhostMobj(player.mo)
		ghs.color = player.mo.color
		ghs.blendmode = AST_ADD
		ghs.fuse = 8
		local sprk = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPALTSPARKLE)
		sprk.momx = P_RandomRange(4, -4)*FRACUNIT
		sprk.momy = P_RandomRange(4, -4)*FRACUNIT
		sprk.momz = P_RandomRange(4, -4)*FRACUNIT
		sprk.color = player.mo.color
		if (player.dtd == nil) then
			player.dtd = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_DTHOKDECTECTOR)
		end
		player.dtd.z = player.mo.z
		if (player.dthokdestroysectortimer == nil) then
			player.dthokdestroysectortimer = 0
		end
		
		if not (player.dthokdestroysectortimer == 1*TICRATE/4) then
			player.dthokdestroysectortimer = $1 + 1
		end

		if (player.dthokdestroysectortimer < 1*TICRATE/4) then
			P_InstaThrust(player.dtd, player.mo.angle, 32*FRACUNIT+player.speed)
		end
		if (player.dthokdestroysectortimer == 1*TICRATE/4) then
			P_InstaThrust(player.dtd, player.mo.angle, player.speed)
		end
		local currentsector = R_PointInSubsector(player.dtd.x, player.dtd.y).sector for fof in currentsector.ffloors()
			if (fof.flags&FF_STRONGBUST) then
				return
			end
			if (fof.flags&FF_EXISTS and fof.flags&FF_BUSTUP) then
				EV_CrumbleChain(currentsector, fof)
			end
		end
	end
end

addHook("PlayerThink", superdropthokghost)

-- desactivate Ghost --

local function superdropthokghostoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if P_IsObjectOnGround(player.mo) or (player.panim ~= PA_JUMP) or (player.usedsecondarythok == true) then
		player.usedsuperdropthok = false
		if (player.dtd and player.dtd.valid) then
			P_KillMobj(player.dtd)
			player.dtd = nil
		end
	end
end

addHook("PlayerThink", superdropthokghostoff)

-- The Super Drop Thok --

local function superdropthok(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.canusest == true) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.blockdthokc3 == true) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.blockdthok == true) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.usedsuperdropthok == true) then
		return
	end
	if (player.canusedthok == false) then
		return
	end
	if (player.usedrecull == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.spincount == true) then
		return
	end
	if (player.jumpdthokblock == true) then
		return
	end
	if (player.ringenergy < 8 and not player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		if not player.pressedsjs
		player.mo.momz = 0*FRACUNIT
		player.ringenergy = $1 - 8
		P_InstaThrust(player.mo, player.mo.angle, 112*FRACUNIT)
		S_StartSound(player.mo, sfx_spdthk)
		player.canusehomingattack = false
		player.lasttkangle = player.mo.angle
		local tk = P_SpawnMobjFromMobj(player.mo, 0, 0, 8*FRACUNIT, MT_ATHOK)
		tk.color = player.mo.color
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
		player.usedsuperdropthok = true
	end
		player.pressedsjs = true
	else
		player.pressedsjs = false
	end
end

addHook("PlayerThink", superdropthok)

-- The Super Drop Thok (water ver) --

local function superdropthokw(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.canusest == true) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.blockdthokc3 == true) then
		return
	end
	if (player.blockdthok == true) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if not (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
	if (player.usedsuperdropthok == true) then
		return
	end
	if (player.canusedthok == false) then
		return
	end
	if (player.usedrecull == true) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.spincount == true) then
		return
	end
	if (player.jumpdthokblock == true) then
		return
	end
	if (player.ringenergy < 8 and not player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		if not player.pressedsjsw
		player.mo.momz = 0*FRACUNIT
		player.ringenergy = $1 - 8
		P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
		S_StartSound(player.mo, sfx_splash)
		player.canusehomingattack = false
		player.lasttkangle = player.mo.angle
		P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_UWEXPLODE)
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
		player.usedsuperdropthok = true
	end
		player.pressedsjsw = true
	else
		player.pressedsjsw = false
	end
end

addHook("PlayerThink", superdropthokw)

-- SECUNDARY THOK --

-- Timer --

local function mjoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usedmj2 == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mjtimer == nil) then
		player.mjtimer = 0
		end

		player.mjtimer = $1 + 1

	if (player.mjtimer == 1*TICRATE) then
		player.usedmj2 = false
		player.bjauraeffect = false
		player.mjtimer = nil
		end
	end

addHook("PlayerThink", mjoff)

-- effects --

local function steffectsw(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		player.bjauraeffect = false
		player.canusepeel = true
		P_SetObjectMomZ(player.mo, 3*FRACUNIT, false)
		P_InstaThrust(player.mo, player.mo.angle, 48*FRACUNIT)
		S_StartSound(player.mo, sfx_splash)
		P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_UWEXPLODE)
		local SECTHOKGW = P_SpawnGhostMobj(player.mo)
		SECTHOKGW.colorized = true
		player.usedsecondarythok = true
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
	end
end


local function steffects(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		return
	end
		player.bjauraeffect = false
		player.canusepeel = true
		P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
		P_InstaThrust(player.mo, player.mo.angle, 48*FRACUNIT)
		S_StartSound(player.mo, sfx_secthk)
		local tk = P_SpawnMobjFromMobj(player.mo, 0, 0, 8*FRACUNIT, MT_ATHOK)
		tk.color = player.mo.color
		local SECTHOKG = P_SpawnGhostMobj(player.mo)
		SECTHOKG.colorized = true
		player.usedsecondarythok = true
		local sprk1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk1.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk1.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk1.color = player.mo.color
		local sprk2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk2.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk2.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk2.color = player.mo.color
		local sprk3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk3.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk3.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk3.color = player.mo.color
		local sprk4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk4.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk4.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk4.color = player.mo.color
		local sprk5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk5.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk5.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk5.color = player.mo.color
		local sprk6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk6.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk6.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk6.color = player.mo.color
		local sprk7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk7.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk7.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk7.color = player.mo.color
		local sprk8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSPARKLE)
		sprk8.momx = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momy = P_RandomRange(8, -8)*FRACUNIT
		sprk8.momz = P_RandomRange(8, -8)*FRACUNIT
		sprk8.color = player.mo.color
	end
	
-- Secundary Thok, to use with Bounce Jump or Recull --

local function secondarythok(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedmj2 == true) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.canusest == false) then
		return
	end
	if (player.usedsecondarythok == true) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.jumpdthokblock == true) then
		return
	end
	if (player.ringenergy < 4 and not player.powers[pw_super]) then
		return
	end
	if (player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		if not player.pressedsja
		player.ringenergy = $1 - 4
		steffects(player)
		steffectsw(player)
	end
		player.pressedsja = true
	else
		player.pressedsja = false
	end
end

addHook("PlayerThink", secondarythok)

-- MAGICAL JUMP --

-- Out off Water --

local function mjnw(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		return
	end	
		player.canusest = true
		player.usedmj = true
		player.bjauraeffect = true
		player.canusedorpdash = false
		player.usedmj2 = true
		player.blockdthok = true
		player.usingbouncejump = false
		player.bjtimer = nil
		player.usedbj = false
		S_StartSound(player.mo, sfx_mj)
		P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
		local MJG = P_SpawnGhostMobj(player.mo)
		MJG.colorized = true
	end

-- In water --

local function mjw(player)
	if (player.mo.eflags & MFE_UNDERWATER) then
		player.canusest = true
		player.blockdthok = true
		player.canusedorpdash = false
		player.usedmj = true
		player.usedbj = false
		player.usingbouncejump = false
		player.bjauraeffect = true
		player.bjtimer = nil
		player.usedmj2 = true
		S_StartSound(player.mo, sfx_mj)
		P_SetObjectMomZ(player.mo, 7*FRACUNIT, false)
		local MJG = P_SpawnGhostMobj(player.mo)
		MJG.colorized = true
	end
end


local function magicaljump(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.ringenergy < 8 and not player.powers[pw_super]) then
		return
	end
	if (player.usingbouncejump == false) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.usedmj == true) then
		return
	end
	if (player.allowmj == false) then
		return
	end
	if (player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		if not player.pressedsjb
		player.ringenergy = $1 - 12
		player.canusepeel = true
		mjw(player)
		mjnw(player)
	end
		player.pressedsjb = true
	else
		player.pressedsjb = false
	end
end

addHook("PlayerThink", magicaljump)

-- SUPER SPSONIC FLY --

-- flying neutral --

local function spsonicflyneutral(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		return
	end
	if (player.speed > 19*FRACUNIT) then
		return
	end
		player.mo.momz = 0
		player.mo.state = S_PLAY_FLOAT
	end

addHook("PlayerThink", spsonicflyneutral)

-- flying run --

local function spsonicflyrun(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.speed < 20*FRACUNIT) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		return
	end
	if (player.speed > 20*FRACUNIT) then
		player.mo.momz = 0
		player.mo.state = S_PLAY_FLOAT_RUN
	end
end

addHook("PlayerThink", spsonicflyrun)

-- Flying up --

local function spsonicflyup(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
	end
	if (player.speed < 20*FRACUNIT and player.cmd.buttons&BT_JUMP) then
		player.mo.state = S_PLAY_SPRING
	end
	if (player.cmd.forwardmove > 0*FRACUNIT and player.speed < 20*FRACUNIT and player.cmd.buttons&BT_JUMP) then
		P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
	end
end

addHook("PlayerThink", spsonicflyup)

-- Flying down --

local function spsonicflydown(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		P_SetObjectMomZ(player.mo, -12*FRACUNIT, false)
	end
	if (player.speed < 20*FRACUNIT and player.cmd.buttons&BT_SPIN) then
		player.mo.state = S_PLAY_FALL
	end
	if (player.cmd.forwardmove > 0*FRACUNIT and player.speed < 20*FRACUNIT and player.cmd.buttons&BT_SPIN) then
		P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
	end
end

addHook("PlayerThink", spsonicflydown)

-- Flying boost (From Sonic Mania) --

local function spsonicflyboost(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM1) then
		if not player.pressedc1fly
		P_InstaThrust(player.mo, player.mo.angle, 128*FRACUNIT)
		P_FlashPal(player, PAL_WHITE, 8)
		S_StartSound(player.mo, sfx_ssfb)
		S_StartSound(player.mo, sfx_peelr)
		player.rings = $1 - 2
	end
		player.pressedc1fly = true
	else
		player.pressedc1fly = false
	end
end

addHook("PlayerThink", spsonicflyboost)

-- Fly Explosion --

local function extimerfly(player)
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.omegau == true) then
		player.flyext = nil
		return
	end
	local ghs = P_SpawnGhostMobj(player.mo)
	ghs.fuse = 50
	ghs.scale = 2*FRACUNIT
	ghs.color = player.mo.color
	ghs.colorized = true
	ghs.blendmode = AST_ADD
	if (player.flyext == nil) then
		player.flyext = 0
	end

	player.flyext = $1+1

	if (player.flyext > 1*TICRATE) then
		player.flyext = nil
		player.flyex = false
		player.omegau = false
	end
end

addHook("PlayerThink", extimerfly)

addHook("MobjCollide", function(mob, obj)
	if not (obj and obj.valid and obj.type == MT_PLAYER) then
		return
	end
	local player = obj.player

	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.flyex == true) then
		return
	end	
	local spkdist = FixedMul(1600*FRACUNIT, player.mo.scale)

	if not (mob.flags&MF_ENEMY) then
		return
	end
	if (P_AproxDistance(P_AproxDistance(player.mo.x-mob.x, player.mo.y-mob.y), player.mo.z-mob.z) < spkdist) then
		S_StartSound(player.mo, mob.info.deathsound)
		P_KillMobj(mob, player.mo, player.mo)
		mob.health = 0
	end
end, MT_NULL)

-- activate superfly --

local function spsonicfly(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	player.pflags = $1&~PF_JUMPED&~PF_SPINNING
	player.usingfly = true
	player.mo.momz = 0
end

addHook("AbilitySpecial", spsonicfly)

-- Desactivate Fly --

local function desactivatespsonicfly(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.usedisair == true) then
		return
	end
	if (player.cmd.buttons&BT_SPIN) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.cmd.buttons & BT_CUSTOM2) then
		if not player.pressedcustom2
		player.mo.state = S_PLAY_FALL
		player.usingfly = false
	end
		player.pressedcustom2 = true
	else
		player.pressedcustom2 = false
	end
end

addHook("PlayerThink", desactivatespsonicfly)

local function forceflyoff(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingfly == false) then
		return
	end
	if (player.panim == PA_RIDE) then
		player.usingfly = false
	end
end

addHook("PlayerThink", forceflyoff)

-- superspsonicchaoscontrol preparatives --

local function preparatives(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM3) then
		player.canusedropdash = false
		player.blockdthokc3 = true
		player.mo.target = nil
	else
		player.canusedropdash = true
		player.blockdthokc3 = false
	end
end

addHook("PlayerThink", preparatives)

-- Super SP.Sonic secret movement --

local function superspsonicchaoscontrol(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.rings < 70) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.usingboucejump == true) then
		return
	end
	if (player.panim ~= PA_JUMP) then
		return
	end
	if (player.speed > 0*FRACUNIT) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM3 and player.cmd.buttons&BT_TOSSFLAG and player.cmd.buttons&BT_SPIN and player.cmd.buttons&BT_JUMP) then
		player.blockdthok = true
		player.blockringrefill = true
		player.chaostarget = P_LookForEnemies(player, true, true)
		if (player.chaostarget and player.chaostarget.valid) then
			P_DamageMobj(player.chaostarget, player.mo, player.mo, 5)
		end
		player.chaostarget2 = P_LookForEnemies(player, true, true)
		if (player.chaostarget2 and player.chaostarget2.valid) then
			P_DamageMobj(player.chaostarget2, player.mo, player.mo, 5)
		end
		player.chaostarget3 = P_LookForEnemies(player, true, true)
		if (player.chaostarget3 and player.chaostarget3.valid) then
			P_DamageMobj(player.chaostarget3, player.mo, player.mo, 5)
		end
		player.chaostarget4 = P_LookForEnemies(player, true, true)
		if (player.chaostarget4 and player.chaostarget4.valid) then
			P_DamageMobj(player.chaostarget4, player.mo, player.mo, 5)
		end
		player.chaostarget5 = P_LookForEnemies(player, true, true)
		if (player.chaostarget5 and player.chaostarget5.valid) then
			P_DamageMobj(player.chaostarget5, player.mo, player.mo, 5)
		end
		player.chaostarget6 = P_LookForEnemies(player, true, true)
		if (player.chaostarget6 and player.chaostarget6.valid) then
			P_DamageMobj(player.chaostarget6, player.mo, player.mo, 5)
		end
		player.chaostarget7 = P_LookForEnemies(player, true, true)
		if (player.chaostarget7 and player.chaostarget7.valid) then
			P_DamageMobj(player.chaostarget7, player.mo, player.mo, 5)
		end
		player.chaostarget8 = P_LookForEnemies(player, true, true)
		if (player.chaostarget8 and player.chaostarget8.valid) then
			P_DamageMobj(player.chaostarget8, player.mo, player.mo, 5)
		end
		player.chaostarget9 = P_LookForEnemies(player, true, true)
		if (player.chaostarget9 and player.chaostarget9.valid) then
			P_DamageMobj(player.chaostarget9, player.mo, player.mo, 5)
		end
		player.chaostarget10 = P_LookForEnemies(player, true, true)
		if (player.chaostarget10 and player.chaostarget10.valid) then
			P_DamageMobj(player.chaostarget10, player.mo, player.mo, 5)
		end
		P_FlashPal(player, PAL_WHITE, 10)
		A_FindTarget(player.mo , MT_SIGN, 0)
		if (player.mo.target and player.mo.target.valid) then
			P_GivePlayerRings(player, -9999)
			S_StopMusic(player)
			S_StopSound(player.mo)
			S_StartSound(player.mo, sfx_s3k9c)
			P_TeleportMove(player.mo, player.mo.target.x+P_RandomRange(64, -64)*FRACUNIT, player.mo.target.y+P_RandomRange(64, -64)*FRACUNIT, player.mo.target.z+2)
		end
	end
end

addHook("PlayerThink", superspsonicchaoscontrol)

-- SUPER SP.SONIC ILIMITED ENERGY --

local function superenergy(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usedsuperringrefill == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.powers[pw_super]) then
		player.ringenergy = 80
	end
end

addHook("PlayerThink", superenergy)

-- SUPER RING REFILL -- 

local function superringrefill(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usedsuperringrefill == true) then
		return
	end
	if not (player.powers[pw_super]) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.buttons&BT_WEAPONNEXT and player.cmd.buttons&BT_WEAPONPREV) then
		player.rings = $1 + 20
		player.ringenergy = 0
		player.usedsuperringrefill = true
	end
end

addHook("PlayerThink", superringrefill)

-- SUPER SP.SONIC TRANSFORM --

-- Timer --

local function trnstimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.trnsforming == true) then
		if (player.trtimer == nil) then
			player.trtimer = 0
			end

		player.trtimer = $1 + 1

		if (player.trtimer == 5) then
			S_StartSound(player.mo, sfx_strns, player)
			player.trtimer = nil
			player.trnsforming = false
		end
		return
	end
	if (player.startttimer == false) then
		return
	end
	if (player.ttimer == nil) then
		player.ttimer = 0
		end

	player.ttimer = $1 + 1

	if (player.ttimer == 7) then
		player.startttimer = false
		player.ttimer = nil
		P_FlashPal(player, PAL_WHITE, 20)
		P_DoSuperTransformation(player, false)
		player.trnsforming = true
		player.unlockssonictimer = true
		player.untrnssound = true
		player.dtd = nil
	end
end

addHook("PlayerThink", trnstimer)

local function unlocksupersonictimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.unlockssonictimer == false) then
		return
	end
	if (player.usstimer == nil) then
		player.usstimer = 0
	end

	player.usstimer = $1 + 1

	if (player.usstimer == 3*TICRATE/2) then
		player.blocksuperblock = false
		player.unlockssonictimer = false
		player.usstimer = nil
	end
end

addHook("PlayerThink", unlocksupersonictimer)

-- To activate Transform --

local function spsonictransform(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.rings < 50) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.pflags&PF_FINISHED) then
		return
	end
	if (player.drawc3options == true and player.cmd.buttons&BT_JUMP) and All7Emeralds(emeralds) then
		player.usingboost = false
		player.blocksuperblock = true
		player.startttimer = true
		player.mo.state = S_PLAY_JUMP
		player.charflags = SF_SUPER|SF_NOSHIELDABILITY
		P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
		player.pfalgs = PF_FULLSTASIS
	end
end

addHook("PlayerThink", spsonictransform)

local function superlight(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.powers[pw_super] and player.lighting == false) then
		player.sspsoniclight = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSONICLIGHT)
		player.sspsonicaura = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPSONICAURA)
		player.sspsoniclight.target = player.mo
		player.sspsonicaura.target = player.mo
		player.lighting = true
	end
	if (player.powers[pw_super] and player.lighting == true) then
		player.sspsonicaura.color = SKINCOLOR_YELLOW
	end
	if not (player.powers[pw_super]) and (player.lighting == true) and (player.sspsoniclight and player.sspsoniclight.valid) and (player.sspsonicaura and player.sspsonicaura.valid) then
		P_KillMobj(player.sspsoniclight)
		P_KillMobj(player.sspsonicaura)
		player.lighting = false
		player.usedsuperringrefill = false
	end
end

addHook("PlayerThink", superlight)

-- SPEED BLAST --

-- speed blast off timer --

local function spedblasttimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusepdblst == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.sdbstftimer == nil) then
		player.sdbstftimer = 0
		end
	
	player.sdbstftimer = $1 + 1

	if (player.sdbstftimer > 3*TICRATE) then
		S_StartSound(player.mo , sfx_spbsf)
		player.mo.colorized = false
		player.canusepdblst = false
		player.sdbstftimer = nil
	end
end

addHook("PlayerThink", spedblasttimer)

-- "can use" color timer --

local function canusespedblstcolor(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusepdblst == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.sbcolortimer == nil) then
		player.sbcolortimer = 0
		end

	player.sbcolortimer = $1 + 1

	if (player.sbcolortimer == 1*TICRATE/10 and player.mo.colorized == false) then
		player.mo.colorized = true
		player.sbcolortimer = nil
	end
	if (player.sbcolortimer == 1*TICRATE/10 and player.mo.colorized == true) then
		player.mo.colorized = false
		player.sbcolortimer = nil
	end	
end

addHook("PlayerThink", canusespedblstcolor)

-- "using" color timer --

local function spedblstcolor(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.usingspdblast == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.sbcolortimer == nil) then
		player.sbcolortimer = 0
		end

	player.sbcolortimer = $1 + 1

	if (player.sbcolortimer == 1*TICRATE/10 and player.mo.colorized == false) then
		player.mo.colorized = true
		player.sbcolortimer = nil
	end
	if (player.sbcolortimer == 1*TICRATE/10 and player.mo.colorized == true) then
		player.mo.colorized = false
		player.sbcolortimer = nil
	end	
end

addHook("PlayerThink", spedblstcolor)


-- Starting blast timer --

local function startingblsttimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.startingspdblst == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.sbstartingtimer == nil) then
		player.sbstartingtimer = 0
		end

	player.sbstartingtimer = $1 + 1

	if (player.sbstartingtimer == 1*TICRATE) then
		player.startingspdblst = false
		player.mo.colorized = false
		player.sbstartingtimer = nil
		player.lastangle = player.mo.angle
		if (player.mo.flags2 & MF2_TWOD) then
			if (player.cmd.sidemove < 0) then
				player.sbforw = true
				player.sbback = false
				player.sbleft = false
				player.sbright = false
			end
			if (player.cmd.sidemove > 0) then
				player.sbforw = true
				player.sbback = false
				player.sbleft = false
				player.sbright = false
			end
			if (player.cmd.buttons&BT_SPIN) then
				player.sbup = true
				player.sbforw = false
				player.sbback = false
				player.sbleft = false
				player.sbright = false
				player.sbanalog = false
				return
			end
			if (player.cmd.sidemove < 0) or (player.cmd.sidemove > 0) or
			(player.cmd.buttons&BT_SPIN) then
				player.ringenergy = $1 - 32
			end			
		end
		if (player.mo.flags2 & MF2_TWOD) then
			return
		end
		if (player.cmd.forwardmove < 0 and player.pflags&~PF_ANALOGMODE) then
			player.sbforw = false
			player.sbback = true
			player.sbleft = false
			player.sbright = false
		end
		if (player.cmd.forwardmove > 0 and player.pflags&~PF_ANALOGMODE) then
			player.sbforw = true
			player.sbback = false
			player.sbleft = false
			player.sbright = false
		end
		if (player.cmd.sidemove < 0 and player.pflags&~PF_ANALOGMODE) then
			player.sbforw = false
			player.sbback = false
			player.sbleft = true
			player.sbright = false
		end
		if (player.cmd.sidemove > 0 and player.pflags&~PF_ANALOGMODE) then
			player.sbforw = false
			player.sbback = false
			player.sbleft = false
			player.sbright = true
		end
		if (player.cmd.forwardmove ~= 0 and player.pflags&PF_ANALOGMODE) or
		(player.cmd.sidemove ~= 0 and player.pflags&PF_ANALOGMODE) then
			player.sbforw = false
			player.sbback = false
			player.sbleft = false
			player.sbright = false
			player.sbanalog = true
		end
		if (player.cmd.buttons&BT_SPIN) then
			player.sbup = true
			player.sbforw = false
			player.sbback = false
			player.sbleft = false
			player.sbright = false
			player.sbanalog = false
			return
		end
		if (player.powers[pw_super]) then
			return
		end
		if (player.cmd.forwardmove < 0) or (player.cmd.forwardmove > 0) or
		(player.cmd.sidemove < 0) or (player.cmd.sidemove > 0) or
		(player.cmd.buttons&BT_SPIN) then
			player.ringenergy = $1 - 32
		end			
	end
end

addHook("PlayerThink", startingblsttimer)

-- use speedblast --

local function usespeedblast(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canusepdblst == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.cmd.forwardmove ~= 0) then
		return
	end
	if (player.cmd.sidemove ~= 0) then
		return
	end
	if not (player.pflags&PF_JUMPED) then
		return
	end
	if (player.cmd.buttons&BT_JUMP) then
		if not (player.mo.eflags&MFE_VERTICALFLIP) then
			player.mo.z = $1 + 12*FRACUNIT
		else
			player.mo.z = $1 - 12*FRACUNIT
		end
		S_StartSound(player.mo , sfx_spbs)
		player.startingspdblst = true
		player.mo.colorized = false
		player.blockallabilities = true
		player.canusepdblst = false
		player.sdbstftimer = nil
	end
end

addHook("PlayerThink", usespeedblast)

local function spbsstopplayerinair(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.startingspdblst == true) then
		player.mo.momz = 0
	end
end

addHook("PlayerThink", spbsstopplayerinair)

-- Stuns --

local function spstunfor(player)
	if (player.sbup == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	player.mo.state = S_PLAY_PAIN
	P_InstaThrust(player.mo, player.lastangle, -24*FRACUNIT)
end

local function spstunback(player)
	if (player.sbup == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	player.mo.state = S_PLAY_PAIN
	P_InstaThrust(player.mo, player.lastangle, 24*FRACUNIT)
end

local function spstunleft(player)
	if (player.sbup == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	player.mo.state = S_PLAY_PAIN
	P_InstaThrust(player.mo, player.lastangle-ANGLE_90, 24*FRACUNIT)
end

local function spstunright(player)
	if (player.sbup == true) then
		return
	end
	if (player.midjump == false) then
		return
	end
	player.mo.state = S_PLAY_PAIN
	P_InstaThrust(player.mo, player.lastangle-ANGLE_90, -24*FRACUNIT)
end

-- Up Movement --

local function spdblstup(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbup == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.usingspdblast == true and player.mo.momz < 8*FRACUNIT) or (player.ringenergy == 0) then
		player.usingspdblast = false
		player.sbup = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.mo.state = S_PLAY_PAIN
		player.pflags = $&~PF_JUMPED
		if (player.ringenergy == 0) then
			S_StartSound(player.mo, sfx_spbsf)
		end
		if (player.ringenergy ~= 0) then
			S_StartSound(player.mo, sfx_crnc)
		end
		return
	end	
	P_SetObjectMomZ(player.mo, 24*FRACUNIT, false)
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.sbup = true
	player.usingspdblast = true
	player.mo.momx = 0
	player.mo.momy = 0
end

addHook("PlayerThink", spdblstup)

local function spdblstup2(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbup == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if not (player.mo.eflags&MFE_VERTICALFLIP) then
		return
	end
	if (player.usingspdblast == true and player.mo.momz > -8*FRACUNIT) or (player.ringenergy == 0) then
		player.usingspdblast = false
		player.sbup = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.mo.state = S_PLAY_PAIN
		player.pflags = $&~PF_JUMPED
		if (player.ringenergy == 0) then
			S_StartSound(player.mo, sfx_spbsf)
		end
		if (player.ringenergy ~= 0) then
			S_StartSound(player.mo, sfx_crnc)
		end
		return
	end	
	P_SetObjectMomZ(player.mo, 24*FRACUNIT, false)
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.sbup = true
	player.usingspdblast = true
	player.mo.momx = 0
	player.mo.momy = 0
end

addHook("PlayerThink", spdblstup2)

local function uptimer(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbup == false) then
		return
	end
	if (player.powers[pw_super]) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.upringtimer == nil) then
		player.upringtimer = 0
	end

	player.upringtimer = $1 + 1

	if (player.upringtimer == 1*TICRATE/5) then
		player.ringenergy = $1 - 4
		player.upringtimer = nil
	end
end

addHook("PlayerThink", uptimer)

-- Forward Movement --

local function spdblstforward(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbforw == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true and player.speed < 60*FRACUNIT and player.sbforw == true) then
		player.usingspdblast = false
		player.sbforw = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.pflags = $&~PF_JUMPED
		player.mo.state = S_PLAY_PAIN
		P_InstaThrust(player.mo, player.lastangle, -24*FRACUNIT)
		S_StartSound(player.mo, sfx_crnc)
		return
	end
	P_InstaThrust(player.mo, player.lastangle, 128*FRACUNIT)
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.usingspdblast = true
	player.mo.momz = 0
end

addHook("PlayerThink", spdblstforward)

-- Backward Movement --

local function spdblstbackward(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbback == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true and player.speed < 60*FRACUNIT and player.sbback == true) then
		player.usingspdblast = false
		player.sbback = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.pflags = $&~PF_JUMPED
		player.mo.state = S_PLAY_PAIN
		P_InstaThrust(player.mo, player.lastangle, 24*FRACUNIT)
		S_StartSound(player.mo, sfx_crnc)
		return
	end
	P_InstaThrust(player.mo, player.lastangle, -128*FRACUNIT)	
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.usingspdblast = true
	player.mo.momz = 0
end

addHook("PlayerThink", spdblstbackward)

-- Rightward Movement --

local function spdblstright(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbright == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true and player.speed < 60*FRACUNIT and player.sbright == true) then
		player.usingspdblast = false
		player.sbright = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.pflags = $&~PF_JUMPED
		player.mo.state = S_PLAY_PAIN
		P_InstaThrust(player.mo, player.lastangle-ANGLE_90, -24*FRACUNIT)
		S_StartSound(player.mo, sfx_crnc)
		return
	end
	P_InstaThrust(player.mo, player.lastangle-ANGLE_90, 128*FRACUNIT)
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.usingspdblast = true
	player.mo.momz = 0
end

addHook("PlayerThink", spdblstright)

-- Leftward Movement --

local function spdblstleft(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbleft == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true and player.speed < 60*FRACUNIT and player.sbleft == true) then
		player.usingspdblast = false
		player.sbleft = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.pflags = $&~PF_JUMPED
		player.mo.state = S_PLAY_PAIN
		P_InstaThrust(player.mo, player.lastangle-ANGLE_90, 24*FRACUNIT)
		S_StartSound(player.mo, sfx_crnc)
		return
	end
	P_InstaThrust(player.mo, player.lastangle-ANGLE_90, -128*FRACUNIT)
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.usingspdblast = true
	player.mo.momz = 0
end

addHook("PlayerThink", spdblstleft)

-- Speed Blast for analog controls --

local function spdblstanalog(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.sbanalog == false) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true and player.speed < 60*FRACUNIT and player.sbanalog == true) then
		player.usingspdblast = false
		player.sbanalog = false
		player.mo.colorized = false
		player.blockallabilities = false
		player.pflags = $&~PF_JUMPED
		player.mo.state = S_PLAY_PAIN
		P_InstaThrust(player.mo, player.lastangle, -24*FRACUNIT)
		S_StartSound(player.mo, sfx_crnc)
		return
	end
	P_InstaThrust(player.mo, player.lastangle, 128*FRACUNIT)
	P_SpawnGhostMobj(player.mo)
	player.drawangle = player.lastangle
	player.usingspdblast = true
	player.mo.momz = 0
end

addHook("PlayerThink", spdblstanalog)

local function speedblastdamage(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true) then
		player.mo.frame = ($1 & FF_FRAMEMASK)|FF_FULLBRIGHT
		local enemydist = FixedMul(256*FRACUNIT, player.mo.scale)
		player.sbetarget1 = P_LookForEnemies(player, false, true)
		player.sbetarget2 = P_LookForEnemies(player, false, true)
		player.sbetarget3 = P_LookForEnemies(player, false, true)
		if (player.powers[pw_super]) then
			player.charflags = SF_SUPER|SF_CANBUSTWALLS|SF_NOSHIELDABILITY
		else
			player.charflags = SF_CANBUSTWALLS|SF_NOSHIELDABILITY
		end
		if (player.sbetarget1 and player.sbetarget1.valid) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.sbetarget1.x, player.mo.y-player.sbetarget1.y), player.mo.z-player.sbetarget1.z) < enemydist) then
			P_DamageMobj(player.sbetarget1, player.mo, player.mo, 4)
			player.sbetarget1 = nil
			player.sbetarget2 = P_LookForEnemies(player, false, true)
			player.sbetarget3 = P_LookForEnemies(player, false, true)
		end
		if (player.sbetarget2 and player.sbetarget2.valid) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.sbetarget2.x, player.mo.y-player.sbetarget2.y), player.mo.z-player.sbetarget2.z) < enemydist) then
			P_DamageMobj(player.sbetarget2, player.mo, player.mo, 4)
			player.sbetarget2 = nil
			player.sbetarget3 = P_LookForEnemies(player, false, true)
		end
		if (player.sbetarget3 and player.sbetarget3.valid) and (P_AproxDistance(P_AproxDistance(player.mo.x-player.sbetarget3.x, player.mo.y-player.sbetarget3.y), player.mo.z-player.sbetarget3.z) < enemydist) then
			P_DamageMobj(player.sbetarget3, player.mo, player.mo, 4)
			player.sbetarget3 = nil
		end
	end
end

addHook("PlayerThink", speedblastdamage)

local function spbothereffect(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true) then
		local sprk = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPALTSPARKLE)
		sprk.momx = P_RandomRange(4, -4)*FRACUNIT
		sprk.momy = P_RandomRange(4, -4)*FRACUNIT
		sprk.momz = P_RandomRange(4, -4)*FRACUNIT
		sprk.color = player.mo.color
	end
end

addHook("PlayerThink", spbothereffect)

local function forcedesactivatespdblst(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.usingspdblast == true and player.midjump == false) then
		player.mo.colorized = false
		player.blockallabilities = false
		player.sbforw = false
		player.sbback = false
		player.sbleft = false
		player.sbright = false
		player.sbanalog = false
		player.usingspdblast = false
	end
end

addHook("PlayerThink", forcedesactivatespdblst)

local function speedblastblockhoming(player)
	if (player.canusepdblst == true) then
		player.canusehoming = false
	end
end

addHook("PlayerThink", speedblastblockhoming)

local function speedblast(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.usingboost == false) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if  (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.blockallabilities == true) then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end
	if (player.speed < 32*FRACUNIT) then
		return
	end
	if (player.pflags&PF_SPINNING) then
		return
	end
	if (player.usingfly == true) then
		return
	end
	if (player.midjump == true) then
		return
	end
	if (player.canuseisairs == false) then
		return
	end
	if (player.usingbouncejump == true) then
		return
	end
	if (player.cmd.buttons&BT_CUSTOM2) then
		if (player.ringenergy > 31) or (player.powers[pw_super]) then
			player.canusepdblst = true
		end
		instastopnoair(player)
		player.usingboost = false
	end
end

addHook("PlayerThink", speedblast)
